--region 游戏工具
--Date
--此文件由[BabeLua]插件自动生成

_gameTools = {}

--打印错误日志
function _gameTools.luaError(msg)
    if gameDef.LogEnable then
        local _msg = debug.traceback(msg, 1)
        Debug.LogError(_msg)
    end
end
--打印警告日志
function _gameTools.luaWarning(msg)
    if gameDef.LogEnable then
        local _msg = debug.traceback(msg, 1)
        Debug.LogWarning(_msg)
    end
end
--打印普通日志
function _gameTools.luaLog(msg)
    if gameDef.LogEnable then
        local _msg = debug.traceback(msg, 1)
        Debug.Log(_msg)
    end
end

--打印table数据
function _gameTools.printTable(tab)
    local str = {}

    local function internal(tab, str, indent)
        for k,v in pairs(tab) do
            if type(v) == "table" then

                table.insert(str, indent..tostring(k)..":\n")
                internal(v, str, indent..' ')
            else
                table.insert(str, indent..tostring(k)..": "..tostring(v).."\n")
            end
        end
    end

    internal(tab, str, '  ')
    return table.concat(str, '  ')
end

--打印网络消息日志信息
--function _gameTools.printMsg(uniqueId, data)
--    if gameDef.MsgLogEnable then
--        local logStr = ""
--        for k, v in pairs(data) do
--            if type(v) == "table" then
--                logStr = logStr .. k ..": \n" .. _gameTools.printTable(v)
--            else
--                logStr = logStr .. k .. ": ".. tostring(v) .. "\n"
--            end
--        end
--        logStr = string.format("<color=green>msg print : '%s' \n %s</color>", uniqueId, logStr)
--        local _msg = debug.traceback(logStr, 1)
--        Debug.LogWarning(_msg)
--    end
--end

--正则表达式切割字符串
function _gameTools.splitString(str, delimiter)
    if str==nil or str=='' or delimiter==nil then
		return nil
	end
	
    local result = {}
    for match in (str..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end

function _gameTools.stringToByteArr(str)
    local bArr = {}
    local len = string.len(str)
    for i = 1,len do
        table.insert(bArr, string.byte(string.sub(str,i,i)))
    end
    return bArr
end

function splitByOp(str)
	local op = ''
	local opfunc = str:gmatch('[><=!]')
	local value = opfunc()
	while(value ~= nil)
	do
		op = op .. value
		value = opfunc()
	end

	if op=='' then
		return {}, nil
	end

	return splitToString(str, op), op
end

--分割字符串
function splitToString(str , sep)
	if not sep then
		sep = ','
	end
	return string.split(str, sep)
end

--分隔数字
function splitToNumber(str , sep)
	local result = splitToString(str, sep)
	for i,v in ipairs(result) do
		result[i] = tonumber(v)
	end
	return result
end
--分割语言包
--function splitToLanguage(str , sep)
--	local result = splitToString(str, sep)
--	for i,v in ipairs(result) do
--		result[i] = dataConfigMgr.getLanguage(tonumber(v))
--	end
--	return result
--end
--链接字串组
function contactToString(ary, sep)
	if not sep then
		sep = ','
	end
	local result = nil
	for i,v in pairs(ary) do
		if not result  then
			result = ''
		else
			result = result .. sep
		end
		result = result .. v
	end
	return result
end
--查询是否存在键
function getKeyExist(ary , key)
	for i,v in pairs(ary) do
		if i == key then
			return true
		end
	end
	return false
end
--查询是否存在值
function getValueExist(ary , value)
	for i,v in pairs(ary) do
		if v == value then
			return true
		end
	end
	return false
end
--断言
function assert(exp, info)
	if not exp or exp==false then
		error(info)
	end
end

--推定
function assume(exp, info)
	if not exp or exp==false then
		alert(info)
	end
end

--提示
function alert(info)
	_Class[uiPopupWarning].show(info)
end

--function getCostTextWithColor(isEnough, text)
--    if isEnough==true then
--        return string.format(t_global[18].value, text)
--    else
--        return string.format(t_global[19].value, text)
--    end
--end

function _gameTools.getTableCount(t)
    local count = 0
	for k, v in pairs(t) do
        if v ~= nil then
		    count = count + 1
        end
	end
	return count
end

--通用发消息接口 send 单点发送，单点接收
--function _gameTools.sendMsg(func, argsTab, successCall, tab1, failedCall, tab2)
--    local msg, uniqueId = func(unpack(argsTab))
--    _gameTools.openConnnecting(uniqueId)
--    msg:send(uniqueId, tab1, successCall, tab2, failedCall)
--end

--通用发消息接口 post 单点发送，广播（事件）接收
--function _gameTools.postMsg(func, eventKey, tab, successCallback , ... )
--    local msg, uniqueId = func(...)
--    _gameTools.openConnnecting(uniqueId)
--    msg:send(uniqueId, nil, function(data)
--		if successCallback then
--			successCallback(tab)
--		end
--		eventMgr:broadcastEvent(eventKey, false, data)
--	end, nil, nil)
--end

function _gameTools.myUnpack(t, ...)
    if table.maxn(t) > 0 then
        local v = table.remove(t, 1)
        return _gameTools.myUnpack(t, ..., v)
    end
end

--打开网络遮罩
--function _gameTools.openConnnecting(uniqueId)
--    local uiData = uiMgr:getUI(_UIConfig.UIConnecting)
--    uiData:onShow(uniqueId)
--end
--function _gameTools.closeConnnecting(uniqueId)
--    local uiData = uiMgr:getUI(_UIConfig.UIConnecting)
--    uiData:onHide(uniqueId)
--end

--设置全局遮罩开关
function _gameTools.setInputEnable(bState)
    local globalMask = uiMgr:getUI(_UIConfig.UIGlobalMask)
    if bState then
        globalMask:onHide()
    else
        globalMask:onShow()
    end
end

--加载道具prefab
--function _gameTools.loadGoodsItem()
--    local obj = resMgr:loadObject("ui_goodsitem", "goodsitem")
--    local trans = obj.transform
--    local uiWidget = {}
--    uiWidget.obj = obj
--    uiWidget.icon = trans:Find("imgIcon")
--    uiWidget.num = trans:Find("txtNum")
--    uiWidget.box = trans:Find("imgBox")
--    return uiWidget
--end

--转换时分秒
function _gameTools.transHMS(second)
    if(second < 0)then
        second = 0
    end
    local sec = math.fmod(second, 60)
	local min = math.fmod(math.floor(second / 60), 60)
	local hour = math.floor(second / 3600)
	return string.format("%02d:%02d:%02d", hour, min, sec)
end

--"%Y%m%d%H%M%S"
--时间戳转成具体时间
function _gameTools.transDateFormat(t, format)
    return os.date(format, tonumber(tostring(t/1000)))
end

--传入一个时间点，计算出到这个时间还剩余多少秒
function _gameTools.getRemainingTime(t)
    local curTime = os.time()
    return _gameTools.timeDiff(curTime, t)
end

--计算两个时间之差
function _gameTools.timeDiff(t1, t2)
    return t2 - t1
end

--注册Update到UpdateBeat
function _gameTools.addUpdate(func, obj)
    local updateHandler = UpdateBeat:CreateListener(func, obj)
    UpdateBeat:AddListener(updateHandler)
    return updateHandler
end

--移除Update从Updatebeat
function _gameTools.removeUpdate(updateHandler)
    UpdateBeat:RemoveListener(updateHandler)
end

--计算字符串字符个数，中文字符算一个
function _gameTools.getStringWordNum(str)
    local fontSize = 20
    local lenInByte = #str
    local count = 0
    local i = 1
    while true do
        local curByte = string.byte(str, i)
        if i > lenInByte then
            break
        end
        local byteCount = 1
        if curByte > 0 and curByte < 128 then
            byteCount = 1
        elseif curByte>=128 and curByte<224 then
            byteCount = 2
        elseif curByte>=224 and curByte<240 then
            byteCount = 3
        elseif curByte>=240 and curByte<=247 then
            byteCount = 4
        else
            break
        end
        -- local char = string.sub(str, i, i+byteCount-1)
        i = i + byteCount
        count = count + 1
    end
    return count
end

--检测文字中是否含有屏蔽字
function _gameTools.shieldStr(content)
    local leafs, dict = dataConfigMgr.getShieldStrConfig()
    local msg = content
	local idxs = {}
	for i = 1, #msg do
		local p = i
		local q = p
		local t = dict
		while true do
			if not t[string.byte(msg, q, q)] then
				q = q - 1
				break
			end
			t = t[string.byte(msg, q, q)]
			q = q + 1
		end
		if q >= p then
			local str = string.sub(msg, p, q)
			if leafs[str] then
				-- table.insert(idxs, {b = p, e = q, l = utfstrlen(str)})
				return false
			end
		end
	end
	return true
end

function _gameTools.utfstrlen(str)
	local len = #str
	local left = len
	local cnt = 0
	local arr = { 0, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc }
	while left ~= 0 do
		local tmp = string.byte(str, -left)
		local i = #arr
		while arr[i] do
			if tmp>=arr[i] then 
                left = left - i
                break
            end
			i = i - 1
		end
		cnt = cnt + 1
	end
	return cnt
end

--替换屏蔽字为*
function _gameTools.replaceShieldStr(content)
    local leafs, dict = dataConfigMgr.getShieldStrConfig()
    local msg = content
	local idxs = {}
	for i = 1, #msg do
		local p = i
		local q = p
		local t = dict
		while true do
			if not t[string.byte(msg, q, q)] then
				q = q - 1
				break
			end
			t = t[string.byte(msg, q, q)]
			q = q + 1
		end
		if q >= p then
			local str = string.sub(msg, p, q)
			if leafs[str] then
				table.insert(idxs, {b = p, e = q, l = _gameTools.utfstrlen(str)})
			end
		end
	end
	local str = msg
	for _, v in pairs(idxs) do
		str = string.sub(str, 1, v.b - 1) .. string.rep("*", v.l) .. string.sub(str, v.e + 1)
	end
	return str
end

--打开重连提示
function _gameTools.openReconectWindow(str)
    gameDataManager.reconectCount = gameDataManager.reconectCount + 1

    if gameDataManager.reconectCount <= gameDef.ReconectMaxCount then
        _Class[uiPopupTwoButtons].show(str, function()
            NetworkMgr:SendReconnect()
        end, nil, 
        function()
            gameDataManager.isLoggedIn = false
            levelMgr:changeScene(_ESceneName.Login)
        end, nil)
    else
        _Class[uiPopupSingleConfirm].show("你已经多次重连失败，请重新登录！", function()
            gameDataManager.isLoggedIn = false
            levelMgr:changeScene(_ESceneName.Login)
        end)
    end
end
--发送重连消息
function _gameTools.sendMsgReconnect()
    _gameTools.sendMsg(cs_reconnect, {0, gameDataManager.selectedServer.id, channelLoginInfo.channel_user_id, channelLoginInfo.channel_user_token, 
        channelLoginInfo.channel_code, channelLoginInfo.sub_channel_code, CGameUtil.DeviceID()}, 
        _gameTools.reconnectSuccess, nil, _gameTools.reconnectFailed, nil)
end
--重连成功
function _gameTools.reconnectSuccess(data)
    gameDataManager.reconectInit(data)
end
--重连失败
function _gameTools.reconnectFailed(data)
    if gameDataManager.reconectCount <= gameDef.ReconectMaxCount then
        if data.result == 118 then
            NetworkMgr:CloseConnect()
            _gameTools.switchToLoginScene(data.reason .. ",封号结束时间:".. _gameTools.transDateFormat(data.time * 1000, "%Y/%m/%d %H:%M"))
        else
            _gameTools.openReconectWindow("你已经与服务器断开连接，是否需要重连？")
        end
    else
        _Class[uiPopupSingleConfirm].show("你已经多次重连失败，请重新登录！", function()
            gameDataManager.isLoggedIn = false
            levelMgr:changeScene(_ESceneName.Login)
        end)
    end
end

function _gameTools.bigNumberConvert(value)
    local value = math.floor(tonumber(tostring(value)))
    if value >= 100000000 then
        value = math.floor(value / 100000) / 1000
        value = string.format("%.3f", value)
        local index = string.len(value)
        while string.sub(value, index, index) == "0" do
            index = index - 1
        end
        if string.sub(value, index, index) == "." then
            index = index - 1 
        end
        value = string.sub(value, 1, index)
        return string.format("%s亿", value)
    end
    return value
end

function _gameTools.translateTime(_time)
    local time = tonumber(tostring(_time)) / 1000
    time = gameDataManager.serverTime - time
	local day = math.floor(time / 86400)
	if day > 30 then
		return "1个月以上"
	elseif day > 7 and day <= 30 then
		return "1周以上"
	elseif day > 0 and day <= 7 then
		return string.format("%s天",day)
	end
	local hour = math.floor(time / 3600)
	if hour > 0 then
		return string.format("%s小时",hour)
	end
	local second = math.floor(time / 60)
	return string.format("%s分钟",math.max(1,second))
end

function _gameTools.exitGame()
    _gameTools.sendMsg(cs_exit, {0}, function(data)
        gameDataManager.isLoggedIn = false
        CNetworkManager.Inst:AddEvent(105, nil)
    end, nil)
end

function _gameTools.deletedEmoji(_str)
    local _result = {}
    local k = 1
    while true do
        if k > #_str then break end
        local c = string.byte(_str,k)
        if not c then break end
        if c<192 then
            table.insert(_result, string.char(c))
            k = k + 1
        elseif c<224 then
            k = k + 2
        elseif c<240 then
            if c>=228 and c<=233 then
                local c1 = string.byte(_str,k+1)
                local c2 = string.byte(_str,k+2)
                if c1 and c2 then
                    local a1,a2,a3,a4 = 128,191,128,191
                    if c == 228 then a1 = 184
                    elseif c == 233 then a2,a4 = 190,c1 ~= 190 and 191 or 165
                    end
                    if c1>=a1 and c1<=a2 and c2>=a3 and c2<=a4 then
                        table.insert(_result, string.char(c,c1,c2))
                    end
                end
            end
            k = k + 3
        elseif c<248 then
            k = k + 4
        elseif c<252 then
            k = k + 5
        elseif c<254 then
            k = k + 6
        end
    end
    return table.concat(_result)
end

function _gameTools.mathClamp(value, min, max)
    if value <= min then
        return min
    end

    if value >= max then 
        return max 
    end

    return value
end

--转换长数字为可显示的数字, str为String
function _gameTools.convertNumberToLabelStringInternal(str)
	local sign = ''
	if str[1] == '-' then
	    sign = "-"
	    str = string.sub(1)
    end
	if #str <= 4 then	
		return str
    end
	local d = math.floor(#str / 3)
    local b = #str % 3

	if b == 0 then 	
		local dchar = "???"
		if d - 1 < #_gameTools.digitChars then
			dchar = _gameTools.digitChars [d]
        end
		local s = string.sub(str,1, 3)
		return sign..s..dchar
	elseif b == 1 then
		local dchar = "???"
		if d < #_gameTools.digitChars then
			dchar = _gameTools.digitChars[d + 1]
        end
		return sign..string.sub(str,1,1).."."..string.sub(str,2,2)..string.sub(str,3,3)..dchar
	else 
		local dchar = "???"
		if d < #_gameTools.digitChars then
			dchar = _gameTools.digitChars[d + 1]
        end
		return sign..string.sub(str,1,1)..string.sub(str,2,2).."."..string.sub(str,3,3)..dchar
	end				
end

--转换长数字为可显示的数字, n为number
function _gameTools.convertNumberToLabelString(n)
	local str = _gameTools.convertNumberToRawString(n)
	return _gameTools.convertNumberToLabelStringInternal(str)
end

--转换成数字
function _gameTools.convertNumberToRawString(num)
	local is = tostring(num)
	if string.find(is,'e') == nil and string.find(is,'E') == nil then
		return is
	else
--        local posIndex = string.find(is,'e')
--        _gameTools.luaError(is..  " posIndex:" ..posIndex)
--		local left = string.sub(is,1,posIndex - 1)
--		local right = string.sub(is,posIndex + 2)
--        _gameTools.luaError("left : "..left)
--		local leftNumber = tonumber(left)
--		local rightNumber = tonumber(right)
--		local frac = leftNumber - math.floor(leftNumber)
--		local fracLength = #(frac..'') - 2

--        _gameTools.luaError("fracLength:" .. fracLength)
--		_gameTools.luaError("leftNum0:" .. leftNumber)
--        for i = 1,fracLength do
--			leftNumber = leftNumber * 10
--			rightNumber = rightNumber - 1
--            _gameTools.luaError("leftNum:" .. leftNumber)
--		end
--        _gameTools.luaError("leftNum2:" .. leftNumber)
--		local str = leftNumber..''
--		for i = 1,rightNumber do
--			str = str..'0'
--        end

        local posIndex = string.find(is, "e")
     	local left = string.sub(is,1,posIndex - 1)
		local right = string.sub(is,posIndex + 2)
        local leftNum = ""
        local leftNumArr = splitToString(left, ".")
        local rightNumber = tonumber(right)
        if leftNumArr[2] ~= nil then
            leftNum = leftNum..leftNumArr[1]..leftNumArr[2]
            for i = 1, rightNumber - #leftNumArr[2] do
                leftNum = leftNum .. "0"
            end
            return leftNum
        else
            leftNum = left
            for i = 1, rightNumber do
                leftNum = leftNum .. "0"
            end
            return leftNum
        end
	end
end

--短数字单位
_gameTools.digitChars =
{
	"",
	"K",
	"M",
	"B",
	"T",
	"aa",
	"bb",
	"cc",
	"dd",
	"ee",
	"ff",
	"gg",
	"hh",
	"ii",
	"jj",
	"kk",
	"ll",
	"mm",
	"nn",
	"oo",
	"pp",
	"qq",
	"rr",
	"ss",
	"tt",
	"uu",
	"vv",
	"ww",
	"xx",
	"yy",
	"zz",
	"aaa",
	"bbb",
	"ccc",
	"ddd",
	"eee",
	"fff",
	"ggg",
	"hhh",
	"iii",
	"jjj",
	"kkk",
	"lll",
	"mmm",
	"nnn",
	"ooo",
	"ppp",
	"qqq",
	"rrr",
	"sss",
	"ttt",
	"uuu",
	"vvv",
	"www",
	"xxx",
	"yyy",
	"zzz",
}	

function _gameTools.toStringEx(value)
    if type(value)=='table' then
       return _gameTools.tableToStr(value)
    elseif type(value)=='string' then
        return "\'"..value.."\'"
    else
       return tostring(value)
    end
end

function _gameTools.strToTable(str)
    if str == nil or type(str) ~= "string" then
        return
    end
    
    return loadstring("return " .. str)()
end

function _gameTools.tableToStr(t)
    if t == nil then return "" end
    local retstr= "{"
    local i = 1
    for key,value in pairs(t) do
        local signal = ","
        if i==1 then
            signal = ""
        end

        if key == i then
            retstr = retstr..signal.._gameTools.toStringEx(value)
        else
            if type(key)=='number' or type(key) == 'string' then
                retstr = retstr..signal..'['.._gameTools.toStringEx(key).."]=".._gameTools.toStringEx(value)
            else
                if type(key)=='userdata' then
                    retstr = retstr..signal.."*s".._gameTools.tableToStr(getmetatable(key)).."*e".."=".._gameTools.toStringEx(value)
                else
                    retstr = retstr..signal..key.."=".._gameTools.toStringEx(value)
                end
            end
        end
        i = i+1
    end

     retstr = retstr.."}"
     return retstr
end

function _gameTools.setLocalData(key, value)
    PlayerPrefs.SetString(key, value)
end

function _gameTools.getLocalData(key)
    return PlayerPrefs.GetString(key, "")
end


--获得随机奖励
function _gameTools.randomAward(tableArr)
    local total = 0
    for i = 1,#tableArr do    
        total = total + tableArr[i][1]
    end
    local randomValue = 1 + math.floor( math.random() * total)
    local l = 0
    for i = 1,#tableArr do    
        l = l + tableArr[i][1]
        if randomValue <= l then
            return i
        end
    end
end

--检测新手引导
function _gameTools.checkGuide(id)
    local uiInfo = uiMgr:getUI(_UI.Guide)
    uiInfo:checkGuide(id)
end

--检测是否当前状态下是否有需要触发的引导
function _gameTools.checkAllGuide()
    for index in pairs(t_guideConfig) do
        if t_guideConfig[index].type < 10 then
            _gameTools.checkGuide(index)
        end
    end
end

--是否是有效的拖拽
function _gameTools.isEffectiveDrag(type, gridId)
    local uiInfo = uiMgr:getUI(_UI.Guide)
    if uiInfo.curGuideId ~= 0 then
        local cfg = dataConfigMgr.getGuideCfg(uiInfo.curGuideId)
        if cfg.type == 2 then
            if type == 1 and uiInfo.dragFromId ~= gridId then
                return false
            elseif type == 2 and uiInfo.dragToId ~= gridId then
                return false
            end
        end
    end
    return true
end

--事件打点
function _gameTools.eventDot(id)
    local cfg = dataConfigMgr.getEventDotCfg(id)
    local opts = {}
    opts.type = _DotType.CustomEvent
    opts.args = cfg
    sdkMgr:statisticsDot(opts)
end

--面板弹出动画
function _gameTools.popupShowAnim(obj)
    _DoTweenHelper:ScaleXYZ(obj, Vector3(0.01,0.01,0.01), Ease.Linear, 0, 0, function()
        _DoTweenHelper:ScaleXYZ(obj, Vector3(1.05,1.05,1.05), Ease.Linear, 0.2, 0, function()
            _DoTweenHelper:ScaleXYZ(obj, Vector3(0.95,0.95,0.95), Ease.Linear, 0.15, 0, function()
                _DoTweenHelper:ScaleXYZ(obj, Vector3(1,1,1), Ease.Linear, 0.1, 0, function()
                    
                end)
            end)
        end)
    end)
end
--endregion
