--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "dataConfig/t_battleLevel"
require "dataConfig/t_firearms"
require "dataConfig/t_language"
require "dataConfig/t_guideConfig"
require "dataConfig/t_targetTask"
require "dataConfig/t_eventDot"
require "dataConfig/t_videoPointCfg"

dataConfigMgr = {}

dataConfigMgr.t_firearmsSortListByLv = {}

function dataConfigMgr.init()
    
    for index in pairs(t_firearms) do
        dataConfigMgr.t_firearmsSortListByLv[t_firearms[index].level] = index
    end
end

function dataConfigMgr.getBattleLevel(id)
    if t_battleLevel[id] == nil then
        _gameTools.luaError("id不存在:"..id)
        return nil
    end
    return t_battleLevel[id]
end

function dataConfigMgr.getFirearms(id)
    if t_firearms[id] == nil then
        _gameTools.luaError("id不存在:"..id)
        return nil
    end
    return t_firearms[id]
end

function dataConfigMgr.getFirearmsTab()
    if not t_firearms then
        _gameTools.luaError("t_firearms表不存在:")
    return nil
    end
    return t_firearms
end

--通过等级获取枪械
function dataConfigMgr.getFirearmsByLv(lv)
    local id = dataConfigMgr.t_firearmsSortListByLv[lv]
    if id == nil then
        _gameTools.luaWarning("该等级的枪不存在")
        return nil
    end
    return dataConfigMgr.getFirearms(id)
end

--获取语言表文字内容
function dataConfigMgr.getLanguage(id)
    local data = t_language[id]
    if data == nil then
        _gameTools.luaError("t_language不存在:".. id)
        return ""
    end
    return data.content
end

--获取引导配置表
function dataConfigMgr.getGuideCfg(id)
    local data = t_guideConfig[id]
    if data == nil then
        _gameTools.luaError("t_guideConfig 不存在:"..id)
        return nil
    end
    return data
end

--获取目标任务功能表
function dataConfigMgr.getTargetTaskTab()
    if not t_targetTask then
        _gameTools.luaError("t_targetTask表不存在:")
        return nil
    end
    return t_targetTask
end

--获取事件
function dataConfigMgr.getEventDotCfg(id)
    local data = t_eventDot[id]
    if data == nil then
        _gameTools.luaError("t_eventDot 不存在:"..id)
        return
    end

    return data
end

--获取视频功能点的次数
function dataConfigMgr.getVideoPointNum(id)
    local data = t_videoPointCfg[id]
    if data == nil then
        _gameTools.luaError("t_videoPointCfg 不存在:"..id)
        return
    end
    return data
end

--endregion
