-- region 战斗管理器
-- Date 2017/11/24
-- Author : Edward
-- 此文件由[BabeLua]插件自动生成

require "common/class"
require "common/define"
require "unit/player"
require "unit/enemy"
require "weapon/weapon"
require "unit/bulletFire"
require "unit/eggshell"

BattleManager = Class()

function BattleManager:ctor()
    
end

function BattleManager:init()
   self.enemyList = {}
   self.player = nil

   --敌人枪属性
   self.enemyFirearmsAttr = 
   {
        [1] = { shootPerFire = 2, shootInterval = 0.6, fireInterval = 0.7, stability = 0.485 },
        [2] = { shootPerFire = 4, shootInterval = 0.11, fireInterval = 2.1, stability = 0.375 },
        [3] = { shootPerFire = 3, shootInterval = 0.13, fireInterval = 2.1, stability = 0.365 },
        [4] = { shootPerFire = 3, shootInterval = 0.2, fireInterval = 2.5, stability = 0.455 },
        [5] = { shootPerFire = 1, shootInterval = 1.2, fireInterval = 2.1, stability = 0.455 },
   }

   self.battleRoot = GameObject.New("battleRoot")
   self.battleRoot.transform.position = Vector3.New(0,0,0)

   self.battleEffectRoot = GameObject.New("battleEffectRoot")
   self.battleEffectRoot.transform.position = Vector3.New(0,0,0)

   self.freeBulletFireList = {}
   self.freeZidanList = {}
   self.enemyCanShoot = false
end

function BattleManager:setCurrentLevel(id)
    self.levelId = id
    self.curLevelCfg = dataConfigMgr.getBattleLevel(self.levelId)
    for i = 5,1,-1 do
        if #self.curLevelCfg["wave"..i] > 0 then
            self.maxWave = i
            break
        end
    end

    if self.levelId == 1 then
        self.gunCfg = dataConfigMgr.getFirearms(1000)
    else
        self.gunCfg = dataConfigMgr.getFirearms(gameDataManager.getUseGunLv())
    end
    self.operateMap = {}
    self.unitModeMap = {}
end

function BattleManager:getLevelNeedRes()
    local ret = {}
    local info = self.curLevelCfg

    for i = 5,1,-1 do
        if #self.curLevelCfg["wave"..i] > 0 then
            local info2 = self.curLevelCfg["wave"..i]
            for j = 1, #info2 do
                if #info2[j] > 0 then
                    table.insert(ret, self:packPreloadInfo(1, info2[j][3]))
                end
            end
        end
    end

    table.insert(ret, self:packPreloadInfo(4, info.map))

    table.insert(ret, self:packPreloadInfo(2, info.shootRoad))

    table.insert(ret, self:packPreloadInfo(3, "player0"))
    table.insert(ret, self:packPreloadInfo(3, "player".. info.playerModel))


    table.insert(ret, self:packPreloadInfo(3, "enemy0"))
    for i = 1, #self.curLevelCfg.enemyModel do
        table.insert(ret, self:packPreloadInfo(3, "enemy"..self.curLevelCfg.enemyModel[i]))
    end

    table.insert(ret, self:packPreloadInfo(3, self.gunCfg.model))

    table.insert(ret, self:packPreloadInfo(5, "bulletFire"))

    table.insert(ret, self:packPreloadInfo(5, "muzzleFlash3"))
    table.insert(ret, self:packPreloadInfo(5, "muzzleFlash7"))

    table.insert(ret, self:packPreloadInfo(3, "zidan"))

    table.insert(ret, self:packPreloadInfo(5, "plasterImpact"))

    return ret
end

function BattleManager:getLevelUnloadRes()
    local ret = {}
    for i = 5,1,-1 do
        if #self.curLevelCfg["wave"..i] > 0 then
            local info = self.curLevelCfg["wave"..i]
            for j = 1, #info do
                if #info[j] > 0 then
                    table.insert(ret, "data_"..info[j][3])
                end
            end
        end
    end
    table.insert(ret, "map_"..self.curLevelCfg.map)
    table.insert(ret, "data_"..self.curLevelCfg.shootRoad)
    table.insert(ret, "unit_player0")
    table.insert(ret, "unit_player"..self.curLevelCfg.playerModel)
    table.insert(ret, "unit_".."enemy0")
    for i = 1, #self.curLevelCfg.enemyModel do
        table.insert(ret, "unit_".."enemy"..self.curLevelCfg.enemyModel[i])
    end
    table.insert(ret, "unit_"..self.gunCfg.model)
    return ret
end

function BattleManager:isTouchOnTouchObj()
    return self:getUIBattle():isTouchOnTouchObj()
end

function BattleManager:packPreloadInfo(eType, assetName)
    if eType == 5 then
        local info = PreLoadInfo.new(_EPreLoadResType.Effect, assetName)
        info.callBackTable = self
        info.callBackArgs = assetName
        info.callBack = self.loadEnemyModelCB
--        info.callBack = function(obj)
--            self.bulletFirePrefab = obj
--        end
        return info
    elseif eType == 4 then
        local info = PreLoadInfo.new(_EPreLoadResType.Map, assetName)
        info.callBack = function(obj)
            local mapObj = GameObject.Instantiate(obj)
            mapObj.transform:SetParent(self.battleRoot.transform)
            mapObj.transform.localPosition = Vector3.zero

--            mapObj.transform.localPosition = Vector3.New(41.6,3.2,48.53)
--            mapObj.transform.localEulerAngles = Vector3.New(0,90,0)
--            mapObj.transform.localScale = Vector3.New(0.0028,0.0028,0.0028)
        end
        return info
    elseif eType == 3 then
        local info = PreLoadInfo.new(_EPreLoadResType.Unit, assetName)
        info.callBackTable = self
        info.callBackArgs = assetName
        info.callBack = self.loadEnemyModelCB
        return info
    elseif eType == 2 then
        local info = PreLoadInfo.new(_EPreLoadResType.TextData, "p"..tostring(assetName))
        info.callBackTable = self
        info.callBackArgs = "p"..tostring(assetName)
        info.callBack = self.loadTextDataCB
        return info
    elseif eType == 1 then
        local info = PreLoadInfo.new(_EPreLoadResType.TextData, "e"..tostring(assetName))
        info.callBackTable = self
        info.callBackArgs = "e"..tostring(assetName)
        info.callBack = self.loadTextDataCB
        return info
    end
end

function BattleManager:loadTextDataCB(args, res)
    self.operateMap[args] = res
end

function BattleManager:loadEnemyModelCB(args, res)
    self.unitModeMap[args] = res
end

function BattleManager:pause()
    self.lastFightState = self.fightState
    self.fightState = 0
end

function BattleManager:resume()
    self.fightState = self.lastFightState
    self:enemyDie()
end

function BattleManager:startBattle()
    local opts = {}
    opts.type = _DotType.StageStart
    opts.args = {}
    opts.args.levelId = tostring(self.levelId)
    sdkMgr:statisticsDot(opts)

    luaMain.directionalLight:SetActive(false)
    self.curWave = 0
    self.curWaveEnemyNum = 0
    self.spawnEnemyId = 0
    self.fightState = 1
    self.enemyList = {}
    audioMgr:playMusic("battleBg1", true)
    self:spawnPlayer(self.curLevelCfg.shootRoad)
    self:nextWave()

    if self.curLevelCfg.levelWarning and self.curLevelCfg.levelWarning ~= 0 then
        self:getUIBattle():showLevelWarningTips(self.curLevelCfg.levelWarning)
    end
end

function BattleManager:nextWave()
    self.curWave = self.curWave + 1

    if self.curWave > self.maxWave then
        self:setFightEnd(true)
        return
    end

    self.enemyCanShoot = false

    self:setFightState(1)

    --闪光弹
    if self.curLevelCfg.flashBomb[self.curWave] ~= nil and self.curLevelCfg.flashBomb[self.curWave] >= 0 then
        self:showFlashBombImg(self.curLevelCfg.flashBomb[self.curWave])
    end
    
    local index = "wave"..self.curWave
    self.curWaveEnemyNum = 0
    for i = 1, #self.curLevelCfg[index] do
        if #self.curLevelCfg[index][i] > 0 then
            self.curWaveEnemyNum = self.curWaveEnemyNum + 1
            self:spawnEnemy(self.curLevelCfg[index][i])
        end
    end

--    audioMgr:playSound("readygo"..math.random(1,4))
    self.player:startPlayOperate(self.curWave)

    self:getUIBattle():hideGuideShootTips()
    if self.player.gunCfg.type == 5 and (gameDataManager.guideData.isShowSnipeGuide == nil or gameDataManager.guideData.isShowSnipeGuide == 0) then
        battleMgr:getUIBattle():showPressShootTips(2)
    end
    if self.levelId == 1 then
        if self.curWave == 1 then
            self.player.guideLevelScrollState = 1
            self:getUIBattle():showPressShootTips(1)
        elseif self.curWave == 2 then
            coroutine.start(function()
                coroutine.wait(2)
                self.player.guideLevelScrollState = 2
                self:getUIBattle():showScrollShootTips(true)
            end)
        elseif self.curWave == 3 then
            coroutine.start(function()
                coroutine.wait(2)
                self.player.guideLevelScrollState = 3
                self:getUIBattle():showScrollShootTips(false)
            end)
        end
    end
end

function BattleManager:getModelObject(modelName)
    local unitObj = GameObject.Instantiate(self.unitModeMap[modelName])
    return unitObj
end

function BattleManager:spawnPlayer(info)
    local unitObj = self:getModelObject("player0")
    local armRoot = unitObj.transform:Find("Camera/armRoot")
    local armObj = self:getModelObject("player"..self.curLevelCfg.playerModel)
    armObj.transform:SetParent(armRoot.transform)
    armObj.name = "player"
    armObj.transform.localPosition = Vector3(0.05, -2.02, -0.16)
    armObj.transform.localEulerAngles = Vector3(0.53, 6.52, 3.94)
    armObj.transform.localScale = Vector3(0.004,0.004,0.004)
    if self.player == nil then
        self.player = Player.new()
    end
    unitObj.transform:SetParent(self.battleRoot.transform)
    self.player:init(unitObj, self.operateMap["p"..info])
end

function BattleManager:spawnEnemy(info)
    if battleMgr.levelId == 1 then
        local unitObj =  self:getModelObject("enemy0")
        local modelId = self.curLevelCfg.enemyModel[math.random(1, #self.curLevelCfg.enemyModel)]
        local roleUnit =  self:getModelObject("enemy"..modelId)
        roleUnit.transform:SetParent(unitObj.transform)
        roleUnit.transform.localScale = Vector3(0.004,0.004,0.004)
        roleUnit.name = "enemyBody"
        self.spawnEnemyId = self.spawnEnemyId + 1
        if self.enemyList[self.spawnEnemyId] == nil then
            self.enemyList[self.spawnEnemyId] = Enemy.new()
        end
        unitObj.transform:SetParent(self.battleRoot.transform)
        local enemyFirearmsAttrIndex = self.curLevelCfg.firearms[math.random(1, #self.curLevelCfg.firearms)]
        for i = 1,#self.curLevelCfg.appointFirearms,2 do
            if self.curLevelCfg.appointFirearms[i] == self.spawnEnemyId then
                enemyFirearmsAttrIndex = self.curLevelCfg.appointFirearms[i + 1]
            end
        end
        self.enemyList[self.spawnEnemyId]:init(self.spawnEnemyId, unitObj, info[2], enemyFirearmsAttrIndex, self.operateMap["e"..info[3]])
        self.curWaveEnemyNum = self.curWaveEnemyNum - 1
    else
        coroutine.start(function()
            coroutine.wait(info[1])
            local unitObj = self:getModelObject("enemy0")
            local modelId = self.curLevelCfg.enemyModel[math.random(1, #self.curLevelCfg.enemyModel)]
            local roleUnit =  self:getModelObject("enemy"..modelId)
            roleUnit.transform:SetParent(unitObj.transform)
            roleUnit.transform.localScale = Vector3(0.004,0.004,0.004)
            roleUnit.name = "enemyBody"
            self.spawnEnemyId = self.spawnEnemyId + 1
            if self.enemyList[self.spawnEnemyId] == nil then
                self.enemyList[self.spawnEnemyId] = Enemy.new()
            end
            unitObj.transform:SetParent(self.battleRoot.transform)
            local enemyFirearmsAttrIndex = self.curLevelCfg.firearms[math.random(1, #self.curLevelCfg.firearms)]
            for i = 1,#self.curLevelCfg.appointFirearms,2 do
                if self.curLevelCfg.appointFirearms[i] == self.spawnEnemyId then
                    enemyFirearmsAttrIndex = self.curLevelCfg.appointFirearms[i + 1]
                end
            end
            self.enemyList[self.spawnEnemyId]:init(self.spawnEnemyId, unitObj, info[2], enemyFirearmsAttrIndex, self.operateMap["e"..info[3]])

            self.curWaveEnemyNum = self.curWaveEnemyNum - 1
        end)
    end
end

function BattleManager:hitEnemy(enemyId, atk, isShootOnHead)
    self.enemyList[enemyId]:beHit(atk, isShootOnHead)
end

function BattleManager:enemyDie(enemyId)
    if self.levelId == 1 then
        self:getUIBattle():showGuideKillTips()
    end

    if self.curWaveEnemyNum > 0 then
        return
    end

    for index in pairs(self.enemyList) do
        if not self.enemyList[index].isDie then
            return
        end
    end

    if self.fightState ~= 0 then
        self:nextWave()
    end
end

function BattleManager:getAliveEnemy()
    for index in pairs(self.enemyList) do
        if not self.enemyList[index].isDie then
            return self.enemyList[index]
        end
    end

    return nil
end

function BattleManager:isEnemyDie(enemyId)
    return self.enemyList[enemyId].isDie
end

function BattleManager:getUIBattle()
    if self.uiBattle == nil then
        self.uiBattle = uiMgr:getUI(_UI.Battle)
    end
    return self.uiBattle
end

function BattleManager:getFreeBulletFire()
    if #self.freeBulletFireList > 0 then
        return table.remove(self.freeBulletFireList, 1)
    end
    local obj = self:getModelObject("bulletFire")
    obj.transform:SetParent(self.battleEffectRoot.transform)
    return BulletFire.new(obj)
end

function BattleManager:getFreeZidan()
    if #self.freeZidanList > 0 then
        return table.remove(self.freeZidanList, 1)
    end
    local obj = self:getModelObject("zidan")
    obj.transform:SetParent(self.battleEffectRoot.transform)
    return Eggshell.new(obj)
end

function BattleManager:getHitEffect()
    local obj = self:getModelObject("plasterImpact")
    return obj
end

function BattleManager:recoveryEggshell(p)
    table.insert(self.freeZidanList, p)
end

function BattleManager:recoveryBulletFire(p)
    table.insert(self.freeBulletFireList, p)
end

function BattleManager:setFightState(state)
    self.fightState = state
end

function BattleManager:setFightEnd(isWin)
    self.fightState = 0
    self:getUIBattle():hideGuideShootTips()

            local opts = {}
    opts.type = _DotType.StageEnd
    opts.args = {}
    opts.args.levelId = tostring(self.levelId)
    if isWin then
        opts.args.result = 1
        coroutine.start(function()
            coroutine.wait(1.5)
            uiMgr:openUI(_UI.BattleResult, false, true)
            gameDataManager.setGameLv()
        end)
    else
        opts.args.result = 0
        uiMgr:openUI(_UI.BattleResult, false, false)
    end
    sdkMgr:statisticsDot(opts)
end

function BattleManager:checkEnemyInPlayerView(pEnemy)
    local sPos = self.player.cameraCom:WorldToScreenPoint(pEnemy.trans.position)
    
    local dis = Vector3.Distance(pEnemy.trans.position, self.player.trans.position)
    local alpha = 1 - (dis - 10) / 10
    
    sPos.x = sPos.x * (sPos.z > 0 and 1 or -1)
    sPos.y = sPos.y * (sPos.z > 0 and 1 or -1)
    if sPos.x > Screen.width or sPos.x < 0 then
        self:getUIBattle():showEnemyDirTips(sPos, pEnemy, alpha)
    elseif sPos.y > Screen.height or sPos.y < 0 then
        self:getUIBattle():showEnemyDirTips(sPos, pEnemy, alpha)
    else
        self:getUIBattle():hideEnemyDirTips(pEnemy)
    end
end

function BattleManager:showBeHitDirImg(pEnemy)
    local sPos = self.player.cameraCom:WorldToScreenPoint(pEnemy.trans.position + Vector3(0,1.8,0))
    self:getUIBattle():showBeHitDirTips(sPos, pEnemy)
end

function BattleManager:getHitPos(hitName)
    if string.find(hitName, "enemyBody") then
        return 2
    elseif string.find(hitName, "enemyHead") then
        return 1
    else
        return 0
    end
end

function BattleManager:showFlashBombImg(delay)
    self:getUIBattle():showFlashBombImg(delay)
end

function BattleManager:clear()
    self.player:clear()
    for index in pairs(self.enemyList) do
        self.enemyList[index]:clear()
    end
    for i = 0, self.battleRoot.transform.childCount - 1 do
        GameObject.Destroy(self.battleRoot.transform:GetChild(i).gameObject)
    end
end

-- endregion
