--region 事件管理器
--Date 2017/11/24
--Author : Edward 
--此文件由[BabeLua]插件自动生成

require "common/class"

----------------------------事件类-------------------------
EventHandler = Class()

-- 构造函数，参数：回调函数，回调对象, 回调参数
function EventHandler:ctor(callBackEvent, obj)
    self.callBackEvent = callBackEvent
    self.callBackObj = obj
    self.param = nil
end
--执行回调
function EventHandler:doEvent(params)
    if params ~= nil then
        self.param = params
    end
    if self.callBackObj ~= nil then
        self.callBackEvent(self.callBackObj, self.param)
    else
        self.callBackEvent(self.param)
    end
end

-------------------------事件管理类---------------------------
EventManager = Class()
--构造函数
function EventManager:ctor()
    self.eventMap = {}
    self.eventUniqueID = 0
    self.eventKeyMap = {}
end
--添加事件, 参数:回调函数,回调对象,回调参数
function EventManager:registerEvent(eventKey, callBackEvent, obj)
    local eh = EventHandler.new(callBackEvent, obj)
    self.eventUniqueID = self.eventUniqueID + 1
    if self.eventKeyMap[eventKey] == nil then
        self.eventKeyMap[eventKey] = {}
    end
    self.eventKeyMap[eventKey][self.eventUniqueID] = self.eventUniqueID
    self.eventMap[self.eventUniqueID] = eh
    return self.eventUniqueID
end
--移除某个事件
function EventManager:remByUniqueId(uniqueId)
    self.eventMap[uniqueId] = nil
end
--移除一类事件类型
function EventManager:remByEventKey(eventKey)
    local eventsUnique = self.eventKeyMap[eventKey]
    if eventsUnique ~= nil then
        for k in pairs(eventsUnique) do
            self:remByUniqueId(k)
        end
        self.eventKeyMap[eventKey] = nil
    end
end
--执行事件回调,参数:布尔值(事件执行完之后，是否清空该类型事件的注册信息)
function EventManager:broadcastEvent(eventKey, isRemove, params)
    local events = self.eventKeyMap[eventKey]
    if events == nil then
        _gameTools.luaWarning("dispatchEvent : eventKey '"..eventKey.. "' has not been registered")
        return
    end
    for k in pairs(events) do
        if self.eventMap[k] ~= nil then
            self.eventMap[k]:doEvent(params)
            if isRemove then
                self.eventMap[k] = nil
            end
        end
    end
    if isRemove then
        self.eventKeyMap[eventKey] = nil
    end
end
--清除所有事件
function EventManager:clear()
    self.eventMap = {}
end

--endregion
