--region 场景管理器
--Date
--此文件由[BabeLua]插件自动生成

_ESceneName = 
{
    Battle = "Battle",
    MainCity = "MainCity",
}
require "common/class"
require "scene/battleScene"
require "scene/mainCityScene"

LevelManager = Class()

function LevelManager:ctor()
    self.curScene = nil    --当前场景
    self.sceneMap = {}     --所有场景数据
end

function LevelManager:init()
    self:register()
end

function LevelManager:register()
    local battleScene = BattleScene.new()
    self.sceneMap[battleScene.sceneName] = battleScene
    local mainCityScene = MainCityScene.new()
    self.sceneMap[mainCityScene.sceneName] = mainCityScene
end

function LevelManager:getCurSceneName()
    if self.curScene == nil then
        return ""
    end
    return self.curScene.sceneName
end

function LevelManager:getSceneByName(sceneName)
    if self.sceneMap[sceneName] then
        return self.sceneMap[sceneName]
    else
        _gameTools.luaError("不存在的场景 " ..sceneName)
    end
    return nil
end

function LevelManager:enterCurScene()
    if self.curScene ~= nil then
        self.curScene:enterScene()
    else
        _gameTools.luaError("当前场景为空");
    end
end

--切换场景
function LevelManager:changeScene(sceneName)
    local scene = self.sceneMap[sceneName]
    if scene ~= nil then
        self:exitLastScene()
        self.curScene = scene
        self.curScene:handlePreLoad()
    else
        _gameTools.luaError("想要切换的场景不存在")
    end
end

--加载完成的回调
function LevelManager:loadCompleted()
    self:enterCurScene()
end

function LevelManager:exitLastScene()
    self:clearScene()
end

function LevelManager:clearScene()
    if self.curScene ~= nil then
        self.curScene:exitScene()
    end
end

--endregion
