--region sdk管理器
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"
require "sdk/quickSDK"
require "sdk/junhai"

SDKManager = Class()
localData = {}

function SDKManager:loadLocalData()
--    self:getLocalData()
    if localData.videoData == "" or localData.videoData == nil then
        _gameTools.luaError("本地数据为空,SDK取默认数据")
        self:useDefaultData()
    else
        local nowTime = os.time()
        local dl = math.floor(localData.videoData.lastLoginTime / 24 / 60 / 60)
        local dn = math.floor(nowTime / 24 / 60 / 60)

        if dl ~= dn  then
            localData.videoData.videoPointNum = {}
            localData.videoData.lastLoginTime = os.time()
        end
    end
end

function SDKManager:useDefaultData()
    localData.videoData = {}
    localData.videoData.videoPointNum = {}
    localData.videoData.lastLoginTime = -1
end

function SDKManager:saveLocalData()
    _gameTools.setLocalData("wreCS_sdkVideoLocalData", _gameTools.tableToStr(localData.videoData))
end

function SDKManager:getLocalData()
    localData.videoData = _gameTools.strToTable(_gameTools.getLocalData("wreCS_sdkVideoLocalData"))
end

function SDKManager:addVideoPointNum(point)
    self:getVideoPointNum(point)
    local cfgPointNum = dataConfigMgr.getVideoPointNum(point).num
    localData.videoData.videoPointNum[point] = localData.videoData.videoPointNum[point] + 1
    if localData.videoData.videoPointNum[point] >= cfgPointNum then
        localData.videoData.videoPointNum[point] = cfgPointNum
    end
end

function SDKManager:getVideoPointNum(point)
    if not localData.videoData.videoPointNum[point] then
        localData.videoData.videoPointNum[point] = 0
    end
    return localData.videoData.videoPointNum[point]
end

function SDKManager:getVideoPointIsUseUp(point)
    local pointNum = self:getVideoPointNum(point)
    local cfgPointNum = dataConfigMgr.getVideoPointNum(point).num
    if cfgPointNum < 0 then
        return false
    else
        return pointNum >= cfgPointNum and true or false    
    end
end

function SDKManager:ctor()
    self.curSDK = nil
    
    self.curSDK = Junhai.new()
end

function SDKManager:initSDK()
    if self.isBoloyo then
        return
    end

    self:loadLocalData()
    self.curSDK:initSDK()
end

function SDKManager:login()
    if self.curSDK == nil then
        return
    end
    self.curSDK:login()
end

function SDKManager:logout()
    if self.isBoloyo then
        CNetworkManager.Inst:AddEvent(105, nil)
        return   
    end
    self.curSDK:logout()
end

function SDKManager:createRole()
    if self.isBoloyo then
        return
    end
    self.curSDK:createRole()
end

function SDKManager:enterGame()
    if self.isBoloyo then
        return
    end
    self.curSDK:enterGame()
end

function SDKManager:roleUpgrade()
    if self.isBoloyo then
        return
    end
    self.curSDK:roleUpgrade()
end

function SDKManager:exitGame()
    
end

function SDKManager:showAd(opts)
    if self.curSDK == nil then
        return
    end
    self.curSDK:showAd(opts)
end

function SDKManager:statisticsDot(opts)
    if self.curSDK == nil then
        return
    end
    self.curSDK:statisticsDot(opts)
end

function SDKManager:getGameRoleInfo()
    local roleInfo = quicksdk.GameRoleInfo.New()
    roleInfo.serverID = gameDataManager.selectedServer.id
    roleInfo.serverName = gameDataManager.selectedServer.name
    roleInfo.gameRoleName = gameDataManager.getPlayerNickName()
    roleInfo.gameRoleID = tostring(gameDataManager.getId())
    roleInfo.gameRoleBalance = tostring(gameDataManager.getGold())
    roleInfo.vipLevel = tostring(gameDataManager.getPlayerVipLv())
    roleInfo.gameRoleLevel = tostring(gameDataManager.getLevel())
    roleInfo.partyName = ""
    roleInfo.roleCreateTime = tostring(gameDataManager.playerInfo.createTime)

    --以下参数仅360渠道需要
    roleInfo.gameRoleGender = ""
    roleInfo.gameRolePower = ""
    roleInfo.partyId = ""
    roleInfo.professionId = ""
    roleInfo.profession = ""
    roleInfo.partyRoleId = ""
    roleInfo.partyRoleName = ""
    roleInfo.friendlist = ""

    return roleInfo
end


--endregion
