--region 子嗣数据相关接口

function gameDataManager.initChatMsgData()
    gameDataManager.chatMsgData = {}
    gameDataManager.chatMsgData.benfuChatData = {}
    gameDataManager.chatMsgData.kuafuChatData = {}
end

--获取本服聊天数据信息
function gameDataManager.getBenfuChatMsgData()
    if gameDataManager.chatMsgData.benfuChatData == nil then
        gameDataManager.chatMsgData.benfuChatData = {}
        gameDataManager.chatMsgData.benfuHistoryTime = os.time()
    end
    return gameDataManager.chatMsgData.benfuChatData
end

--获取跨服聊天数据信息
function gameDataManager.getKuaFuChatMsgData()
    if gameDataManager.chatMsgData.kuafuChatData == nil then
        gameDataManager.chatMsgData.kuafuChatData = {}
    end
    return gameDataManager.chatMsgData.kuafuChatData
end

function gameDataManager.getZouMaDengChatMsgData()
    if gameDataManager.chatMsgData.zoumadengChatData == nil then
        gameDataManager.chatMsgData.zoumadengChatData = {}
    end
    return gameDataManager.chatMsgData.zoumadengChatData
end

--获取所有聊天信息
function gameDataManager.getAllChatMsgData()
    return gameDataManager.chatMsgData
end

--添加聊天信息
function gameDataManager.addChatMsgData(data)
    --[[
    BenFu = 1,  --本服
    LianMeng = 2,  --联盟
    ZouMaDeng = 3,  --走马灯
    KuaFu = 4,  --跨服
    ]]
    if data.type == _EChatMsgType.BenFu then
        table.insert(gameDataManager.getBenfuChatMsgData(), data)
        gameDataManager.chatMsgData.benfuHistoryTime = data.sendTime
    elseif data.type == _EChatMsgType.KuaFu then
        table.insert(gameDataManager.getKuaFuChatMsgData(), data)
    elseif data.type == _EChatMsgType.LianMeng then
    elseif data.type == _EChatMsgType.ZouMaDeng then
        table.insert(gameDataManager.getZouMaDengChatMsgData(), data)
    end
end

function gameDataManager.addChatMsgDataListToHead(data)
    --[[
    BenFu = 1,  --本服
    LianMeng = 2,  --联盟
    ZouMaDeng = 3,  --走马灯
    KuaFu = 4,  --跨服
    ]]
    for i = #data, 1, -1 do
        if data[i].type == _EChatMsgType.BenFu then
            table.insert(gameDataManager.getBenfuChatMsgData(), 1, data[i])
            gameDataManager.chatMsgData.benfuHistoryTime = data[i].sendTime
        elseif data[i].type == _EChatMsgType.LianMeng then
        elseif data[i].type == _EChatMsgType.ZouMaDeng then
            table.insert(gameDataManager.getZouMaDengChatMsgData(), 1, data[i])
        elseif data[i].type == _EChatMsgType.KuaFu then
            table.insert(gameDataManager.getKuaFuChatMsgData(), 1, data[i])
        end
    end
end

function gameDataManager.addChatMsgDataListToEnd(data)
    --[[
    BenFu = 1,  --本服
    LianMeng = 2,  --联盟
    ZouMaDeng = 3,  --走马灯
    KuaFu = 4,  --跨服
    ]]
    for i = #data, 1, -1 do
        if data[i].type == _EChatMsgType.BenFu then
            table.insert(gameDataManager.getBenfuChatMsgData(), data[i])
            gameDataManager.chatMsgData.benfuHistoryTime = data[i].sendTime
        elseif data[i].type == _EChatMsgType.LianMeng then
        elseif data[i].type == _EChatMsgType.ZouMaDeng then
            table.insert(gameDataManager.getZouMaDengChatMsgData(), data[i])
        elseif data[i].type == _EChatMsgType.KuaFu then
            table.insert(gameDataManager.getKuaFuChatMsgData(), data[i])
        end
    end
end


--endregion
