--region 子嗣数据相关接口

--获取所有子嗣，不区分参见科举和幼年的
function gameDataManager.getAllChildrenListData()
    return gameDataManager.playerInfo.chlidrenlist
end
--更新子嗣数据
function gameDataManager.setChildData(data)
    local childData = gameDataManager.getChildDataFromAllChildren(data.id)
    childData.fight = data.fight
    childData.intelligence = data.intelligence
    childData.politics = data.politics
    childData.charm = data.charm
end

function gameDataManager.refreshMarriageState(data)
    local childData = gameDataManager.getChildDataFromAllChildren(data.id)
    childData.marriagetime = data.marriagetime    
    childData.marriagestate = data.marriagestate    
    childData.requestid = data.requestid    
    childData.requestname = data.requestname    
    childData.requestcountdown = data.requestcountdown    
    childData.marriagename = data.marriagename    
    childData.marriagebsx = data.marriagebsx    
    childData.marriagefathername = data.marriagefathername    
    childData.marriageattr = data.marriageattr    
end
--获取子嗣列表中参加了科举的
function gameDataManager.getKejuChildrenListData()
    return gameDataManager.playerInfo.kejuChlidrenlist or {}
end
--添加子嗣数据到子嗣列表中
function gameDataManager.addNewChildrenToChildrenListData(newChildList)
    for i = 1, #newChildList do
        table.insert(gameDataManager.playerInfo.chlidrenlist, newChildList[i])
    end
    gameDataManager.initChilrenListData()
    uiMgr:getUI(_UIConfig.UIHouse):refreshNpc()
end
--从所有子嗣中获取子嗣数据
function gameDataManager.getChildDataFromAllChildren(id)
    local childList = gameDataManager.getAllChildrenListData()
    for i = 1, #childList do
        if childList[i].id == id then
            return childList[i]
        end
    end
    return nil
end
--初始化子嗣列表
function gameDataManager.initChilrenListData()
    gameDataManager.playerInfo.youngChlidrenlist = {}
    gameDataManager.playerInfo.kejuChlidrenlist = {}
    local allChildrenList = gameDataManager.getAllChildrenListData()
    local t = {}
    local t2 = {}
    for i = 1, #allChildrenList do
        if allChildrenList[i].grownstage == 1 then
            table.insert(t, allChildrenList[i])
        elseif allChildrenList[i].grownstage == 2 then
            table.insert(t2, allChildrenList[i])
        end
    end
    gameDataManager.playerInfo.youngChlidrenlist = t
    gameDataManager.playerInfo.kejuChlidrenlist = t2
end
--获取指定子嗣的数据在列表中的index值
function gameDataManager.getIndexInChildListData(childInfo)
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        if childList[i].id == childInfo.id then
            return i
        end 
    end
    return 1
end
--获取子嗣列表数据,幼年的
function gameDataManager.getChildrenListData()
    return gameDataManager.playerInfo.youngChlidrenlist or {}
end
--从幼年子嗣列表获取对应子嗣数据
function gameDataManager.getChildDataById(id)
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        if childList[i].id == id then
            return childList[i]
        end
    end
    return nil
end
--修改子嗣名字
function gameDataManager.changeChildNameData(id, name)
    local childData = gameDataManager.getChildDataById(id)
    childData.name = name
end
--子嗣培养
function gameDataManager.setChildLevelExpData(id, addLevel, curExp)
    local childData = gameDataManager.getChildDataById(id)
    childData.level = childData.level + addLevel
    childData.exp = curExp
end
--获取子嗣最大活力次数
function gameDataManager.getMaxChildEnergyNum()
    local vipConfig = dataConfigMgr.getVipConfig(gameDataManager.getPlayerVipLv())
    return vipConfig.childVitality
end

-- VIP变更时
function gameDataManager.setChildEnergyNumByVipChanged(newVipLv)
    local oldVipLv = gameDataManager.getPlayerVipLv()
    local oldVipConfig = dataConfigMgr.getVipConfig(oldVipLv)
    local newVipConfig = dataConfigMgr.getVipConfig(newVipLv)
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        childList[i].energy = childList[i].energy + (newVipConfig.childVitality - oldVipConfig.childVitality)
    end
    --gameDataManager.playerInfo.energy = gameDataManager.playerInfo.energy + (newVipConfig.playerEnergy - oldVipConfig.playerEnergy)
end


--是否只有科举和未起名的孩子
function gameDataManager.isOnlyHaveKejuAndNonameChild()
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        local childConfigData = dataConfigMgr.getChildrenYoungIdentityData(childList[i].aptitude)
        if childList[i].name == "" or childList[i].level >= childConfigData.maxLevel then
        else
            return false
        end
    end
    return true
end


--是否有子嗣的活力大于0 
function gameDataManager.isHaveChildrenEnergyMoreThanZero()
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        local childConfigData = dataConfigMgr.getChildrenYoungIdentityData(childList[i].aptitude)
        if childList[i].name ~= "" and childList[i].level < childConfigData.maxLevel and childList[i].energy > 0 then
            return true
        end
    end
    return false
end
--是否有子嗣可操作 
function gameDataManager.isHaveChildrenCanOperate()
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        local childConfigData = dataConfigMgr.getChildrenYoungIdentityData(childList[i].aptitude)
        if(childList[i].name == "") then
            return true
        end
        if(childList[i].level == childConfigData.maxLevel) then
            return true
        end
        if(childList[i].energy > 0) then 
            return true
        end
    end
    return false
end
--减子嗣活力次数
function gameDataManager.subChildEnergyNum(sid, num)
    local childData = gameDataManager.getChildDataById(sid)
    if childData.energy == gameDataManager.getMaxChildEnergyNum() then
        childData.energyCd = t_global[37].value
    end
    if num == -1 then
        childData.energy = 0
    else
        childData.energy = childData.energy - num
    end
end
--重置精力CD
function gameDataManager.resetChildEnergyCD(childInfo)
    if childInfo.energy < gameDataManager.getMaxChildEnergyNum() then
        childInfo.energyCd = t_global[37].value
    end
end
--恢复活力
function gameDataManager.recoverChildEnergy(sid)
    local childData = gameDataManager.getChildDataById(sid)
    childData.energy = gameDataManager.getMaxChildEnergyNum()
    childData.energyCd = 0
end
--科举回调
function gameDataManager.setChildKejuData(data)
    local childData = gameDataManager.getChildDataById(data.sid)
    childData.grownstage = 2
    childData.identity = data.identity
    gameDataManager.initChilrenListData()
end
--获取子嗣席位个数
function gameDataManager.getChildrenSeatCount()
    return gameDataManager.getPlayerStatesByKey(_EPlayerStates.ChildSeat)
end
--恢复所有子嗣活力
function gameDataManager.setChildEnergy(id, energy, cd)
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        if(childList[i].id == id)then
            childList[i].energy = energy
            childList[i].energyCd = cd
        end
    end
end
--子嗣update
function gameDataManager.onChildrenDataUpdate()
    local childList = gameDataManager.getChildrenListData()
    for i = 1, #childList do
        if childList[i].energy < gameDataManager.getMaxChildEnergyNum() then
            childList[i].energyCd = childList[i].energyCd - gameDataManager.realDeltaTime
            if childList[i].energyCd <= 0 then
                childList[i].energy = childList[i].energy + 1
                gameDataManager.resetChildEnergyCD(childList[i])
                eventMgr:broadcastEvent(_EventType.Child_Energy_CD_Check)
            end
        end
    end
end

--endregion

--endregion
