--region 红颜数据
--Date
--此文件由[BabeLua]插件自动生成

--region 红颜数据相关接口

--获取红颜列表数据
function gameDataManager.getWifeInfo()
    return gameDataManager.playerInfo.wifeList
end
function gameDataManager.getWifeDataById(id)
    local wifeList = gameDataManager.getWifeInfo()
    for i = 1, #wifeList do
        if wifeList[i].sid == id then
            return wifeList[i]
        end
    end
end
--添加新的红颜
function gameDataManager.addNewWifeData(newWifeData)
    local wifeList = gameDataManager.getWifeInfo()
    table.insert(wifeList, newWifeData)
end
--传唤红颜时更新红颜经验数据
function gameDataManager.setWifeExpData(data)
    local wifeData = gameDataManager.getWifeDataById(data.sid)
    wifeData.exp = wifeData.exp + data.addexp
end
--更新红颜技能数据
function gameDataManager.setWifeSkillData(data)
    local wifeData = gameDataManager.getWifeDataById(data.sid)
    wifeData.exp = data.exp
    for i = 1, #wifeData.skillList do
        if data.skillsid == wifeData.skillList[i].skillid then
            wifeData.skillList[i].level = data.skilllevel
        end
    end
end
--获取未解锁红颜的配置表数据
function gameDataManager.getDontUnlockWifeData()
    local ret = {}
    local wifeList = gameDataManager.getWifeInfo()
    for i = 1, #wifeList do
        ret[wifeList[i].sid] = 1
    end
    local dontUnlockWifeList = {}
    for k, v in pairs(t_confidante) do
        if ret[k] == nil then
            dontUnlockWifeList[k] = v
        end
    end
    return dontUnlockWifeList
end
--增加指定红颜的亲密度
function gameDataManager.addWifeInitmacyById(sid, addValue)
    local wifeData = gameDataManager.getWifeDataById(sid)
    wifeData.intimacy = wifeData.intimacy + addValue
end
--赏赐成功时调用次接口刷新数据
function gameDataManager.setWifeShangCiData(data)
    local wifeData = gameDataManager.getWifeDataById(data.sid)
    wifeData.intimacy = data.intimacy
    wifeData.charm = data.charm
end
--技能升级调用此、接口刷新数据
function gameDataManager.setWifeSkillUpgradeData(data)
    local wifeData = gameDataManager.getWifeDataById(data.sid)
    wifeData.exp = data.exp
    for i = 1, #wifeData.skillList do
        if data.skillid == wifeData.skillList[i].skillid then
            wifeData.skillList[i].skilllevel = data.skilllevel
        end
    end
end
--添加精力次数
function gameDataManager.addEneryNum()
    gameDataManager.playerInfo.energy = gameDataManager.playerInfo.energy + 1
end
--重置精力CD
function gameDataManager.resetEnergyCD()
    if gameDataManager.playerInfo.energy < gameDataManager.getMaxEnergyNum() then
        gameDataManager.playerInfo.energycd = t_global[38].value
    end
end
--最大精力次数
function gameDataManager.getMaxEnergyNum()
    local vipConfig = dataConfigMgr.getVipConfig(gameDataManager.getPlayerVipLv())
    return vipConfig.playerEnergy
end
-- VIP变更时
function gameDataManager.setEnergyNumByVipChanged(newVipLv)
    local oldVipLv = gameDataManager.getPlayerVipLv()
    local oldVipConfig = dataConfigMgr.getVipConfig(oldVipLv)
    local newVipConfig = dataConfigMgr.getVipConfig(newVipLv)
    gameDataManager.playerInfo.energy = gameDataManager.playerInfo.energy + (newVipConfig.playerEnergy - oldVipConfig.playerEnergy)
end
function gameDataManager.getEnergyCD()
    return gameDataManager.playerInfo.energycd
end
--获取精力次数
function gameDataManager.getEnergyNum()
    return gameDataManager.playerInfo.energy
end
--减精力次数
function gameDataManager.subEnergyNum(num)
    if gameDataManager.playerInfo.energy == gameDataManager.getMaxEnergyNum() then
        gameDataManager.playerInfo.energycd = t_global[38].value
    end
    gameDataManager.playerInfo.energy = gameDataManager.playerInfo.energy - num
end
--恢复精力的消息数据处理
function gameDataManager.resetEnergyState()
    gameDataManager.playerInfo.energy = gameDataManager.getMaxEnergyNum()
    gameDataManager.playerInfo.energycd = 0
end
--红颜update
function gameDataManager.onConfidanteUpdate()
    local energyNum = gameDataManager.getEnergyNum()
    local maxEnergy = gameDataManager.getMaxEnergyNum()
    if energyNum < maxEnergy then
        gameDataManager.playerInfo.energycd = gameDataManager.playerInfo.energycd - Time.deltaTime
        if gameDataManager.playerInfo.energycd <= 0 then
            gameDataManager.addEneryNum()
            gameDataManager.resetEnergyCD()
            eventMgr:broadcastEvent(_EventType.EnergyCdCheck)
        end
    end
end

function gameDataManager.setNewWifeList(_data)
    if gameDataManager.newWifeList == nil then
        gameDataManager.newWifeList = {}
    end
    if t_confidante[_data.sid].isShow == 1 then
        table.insert(gameDataManager.newWifeList, _data)
    end
end

function gameDataManager.getNewWifeList()
    if gameDataManager.newWifeList == nil then
        gameDataManager.newWifeList = {}
    end
    return gameDataManager.newWifeList
end

function gameDataManager.removeShowedWifeItem()
    if gameDataManager.newWifeList ~= nil then
        if #gameDataManager.newWifeList > 0 then
            table.remove(gameDataManager.newWifeList, 1)
        end
    end
end

--endregion

--endregion
