local M = {}
gameDataManager.xunfangData = M

function M:init()
    self.powerIncTime = tonumber(t_global[39].value)
    self.powerIncValue = 1 --tonumber(t_global[8].value)
    self.fotuneIncTime = tonumber(t_global[45].value)
    self.fotuneIncValue = 1 --tonumber(t_global[10].value)
    self.isAutoMoney = gameDataManager.getPlayerStatesByKey(10015) == 1
    self.isAutoFood = gameDataManager.getPlayerStatesByKey(10014) == 1
    self.isAutoXunfang = false
end

function M:load(data)
    self.vipLevel = gameDataManager.playerInfo.vipLv

    local powerGoTime = (data.xfcd > 0) and (self.powerIncTime - data.xfcd) or 0
    local fotuneGoTime = (data.yscd > 0) and (self.fotuneIncTime - data.yscd) or 0

    self.power = data.count
    self.powerMax = data.maxCount
    self.powerTime = os.clock() - powerGoTime

    self.fotune = data.fortune
    self.fotuneTime = os.clock() - fotuneGoTime
end

--时间到则刷新
function M:refreshTimeData()
    if os.clock() - self.powerTime >= self.powerIncTime or os.clock() - self.fotuneTime >= self.fotuneIncTime then
        _gameTools.sendMsg(cs_xunfangGET_INFO, {1}, function(data)
            gameDataManager.xunfangData:load(data)
        end)
    end
end

function M:getLastTime()
    return self.powerIncTime - (os.clock() - self.powerTime)
end

function M:getCurrentPower()
    return self.power
end

function M:getCurrentFotune()
    return self.fotune
end

--返回随机的建筑和非女性NPC
function M:getRandomResult()
    local buildings = {}
    for i,v in pairs(t_xunFangBuilding) do
        local building = {}
        building.data = v
        building.roles = {}
        for j,w in ipairs(v.roles) do
            local role = t_xunFangRole[w]
            if role.type == 0 then --剔除红颜
                table.insert(building.roles, role)
            end
        end
        if #building.roles > 0 then
            table.insert(buildings, building)
        end
    end

    local randBuilding = buildings[math.random(1, #buildings)]
    local randRole = randBuilding.roles[math.random(1, #randBuilding.roles)]

    --print('随机结果：' ,randBuilding.id, randRole.id)

    return randBuilding.data,randRole
end