--region 主城场景
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"

MainCityScene = Class()

function MainCityScene:ctor()
    self.sceneName = _ESceneName.MainCity
end

function MainCityScene:enterScene()
    --切换场景
    if not luaMain.firstLogin and gameDataManager.isFinishGuide(1) then
        _gameTools.eventDot(160)
        luaMain.firstLogin = true
        --设置音效
        audioMgr:setMusicSwitch(gameDataManager.getMusicState())
        audioMgr:setSoundSwitch(gameDataManager.getSoundState())
        --签到
        if gameDataManager.isShowSignPanel() and not gameDataManager.isSignToday() then
            uiMgr:openUI(_UI.Sign)
        end 
        --离线收益
        local offlineVal = gameDataManager.isOfflineIncome()
        if offlineVal then
            uiMgr:openUI(_UI.Offline,false,{offlineVal})
        end
        --恢复体力
        local lastVigorTime = gameDataManager.getFreeVigorTime()
        local vigorNum = math.floor((os.time() - lastVigorTime) / 10 / 60)
        gameDataManager.addVigor(vigorNum,false)
        --今天是否已经登陆
        if not gameDataManager.isLoginToday() then
            gameDataManager.loginToday()
        end
    end
end

function MainCityScene:exitScene()
    --卸载场景资源
    uiMgr:clear()
end

function MainCityScene:getPreLoadRes()
    local loadList = {}

--    table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UIConfig.UIMainCity))
--    table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UIConfig.UIHouse))
--    table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UIConfig.UIGonggao))
    if not uiMgr:isExistOpenList(_UI.FloatTips) then
        table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UI.FloatTips))
    end

    if not uiMgr:isExistOpenList(_UI.Guide) then
        table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UI.Guide))
    end

    table.insert(loadList, PreLoadInfo.new(_EPreLoadResType.UI, _UI.Main))

    return loadList
end

function MainCityScene:handlePreLoad()
    local loadList = self:getPreLoadRes()
    if #loadList > 0 then
        uiMgr:openUI(_UI.Loading, false, {loadList,1})
    else
        self:enterScene()
    end
end



--endregion
