--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"
require "sdk/umengSDK"
require "sdk/junhaiAnalyticsSDK"
require "sdk/faceBookSDK"
require "sdk/upltvSDK"
require "sdk/gameAnalyticsSDK"
require "sdk/appsFlyerSDK"

Junhai = Class()

function Junhai:ctor()
    self.isInited = false
    self.MsgType = 
    {
        InitSuccess = "onInitSuccess",
        LoginSuccess = "onLoginSuccess",
        LogoutSuccess = "onLogoutSuccess",
        SwitchAccount = "onSwitchAccount",
    }

    self.appId = "wx4e0f107160341efc"
    self.appName = "nationalCS"
    self.version = "1.0.1"
    self.appChannel = "google"
end

function Junhai:initSDK()
    self.adSDK = nil
    self.statisticsSDK = {}
    self.junhaiAnalyticsSDK = nil
    self.faceBookSDK = nil

    self.adSDK = UpltvSDK.new()
    self.statisticsSDK = 
    {
        [1] = GameAnalyticsSDK.new(),
        [2] = AppsFlyerSDK.new(),
        [3] = UMengSDK.new()
    }
    self.junhaiAnalyticsSDK = JunhaiAnalyticsSDK.new()
    self.faceBookSDK = FaceBookSDK.new()

    if self.junhaiAnalyticsSDK ~= nil then
        self.junhaiAnalyticsSDK:initSDK()
    end

    if self.faceBookSDK ~= nil then
        self.faceBookSDK:initSDK()
    end
    
    if self.adSDK ~= nil then
        self.adSDK:initSDK()
    end

    for i = 1, #self.statisticsSDK do
        self.statisticsSDK[i]:initSDK()
    end
end

function Junhai:login()
    local headers = System.Collections.Generic.Dictionary_string_string.New()
    headers:Add("X-WRE-APP-ID", self.appId)-- ["X-WRE-APP-ID"] = "wx4e0f107160341efc"
    headers:Add("X-WRE-APP-NAME", self.appName)-- ["X-WRE-APP-NAME"] = "nationalCS"
    headers:Add("X-WRE-VERSION", self.version)-- ["X-WRE-VERSION"] = "1.0.1"
    headers:Add("X-WRE-CHANNEL", self.appChannel)-- ["X-WRE-CHANNEL"] = "google"
    headers:Add("Content-Type", "application/json")-- ["Content-Type"] = "application/json"
--    local str = "{\"code\":\"-1\",\"shareType\":\"0\",\"shareFromUuid\":\"0\",\"shareFromImage\":\"0\",\"sceneId\":0}"
    local sendData = {}
    sendData.code = SystemInfo.deviceUniqueIdentifier
    sendData.shareType = "0"
    sendData.shareFromUuid = "0"
    sendData.shareFromImage = "0"
    sendData.sceneId = 0
    local json1 = require "cjson"
    local str = json1.encode(sendData)

    CGameUtil.DowloadGlobalCfg("https://www.loveballs.club/test/gameapi/v1/users/login", str, headers, function(ret)
        local json = require "cjson"
        local t = json.decode(ret)
        sdkMgr.sessionKey = t.sessionKey
        sdkMgr.isSDKLoggedIn = true
        sdkMgr.uuid = t.uuid
        sdkMgr.gameUserId = t.userId
        sdkMgr.userid = t.userid
        sdkMgr.appToken = t.token
        sdkMgr.openId = t.openId
        sdkMgr.isLegal = t.legal
        sdkMgr.headUrl = t.avatarUrl
        sdkMgr.nickName = t.nickName
        _gameTools.eventDot(157)
        self:loginEvent()
    end)
end

function Junhai:isAdReady()
    if self.adSDK == nil then
        return true
    else
        return self.adSDK:isAdReady()
    end
end

function Junhai:showAd(opts)
    if self.adSDK == nil then
        if opts.callBack ~= nil then
            if opts.objectTable ~= nil then
                opts.callBack(opts.objectTable, true)
            else
                opts.callBack(true)
            end
            sdkMgr:addVideoPointNum(opts.unitId)
        end
    else
        self.adSDK:showAd(opts)
    end
end

function Junhai:statisticsDot(opts)
    if not opts then
        _gameTools.luaError("事件参数不合法")
        return
    end

    for i = 1, #self.statisticsSDK do
        self.statisticsSDK[i]:statisticsDot(opts)
    end
end

function Junhai:loginEvent()
    if self.junhaiAnalyticsSDK ~= nil then
        self.junhaiAnalyticsSDK:loginEvent()
    end
end

--endregion
