--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"

QuickSDK = Class()

function QuickSDK:ctor()
    self.isInited = false
--    self.channel_user_id = ""
--    self.channel_user_token = ""
--    self.channel_code = ""
--    self.sub_channel_code = ""
    self.MsgType = 
    {
        InitSuccess = "onInitSuccess",
        LoginSuccess = "onLoginSuccess",
        LogoutSuccess = "onLogoutSuccess",
        SwitchAccount = "onSwitchAccount",
    }
end

function QuickSDK:initSDK()
    if self.isInited then
        if sdkMgr.isSwitchAccount then
            sdkMgr.isSwitchAccount = false
            self:onLoginSuccess(gameDataManager.sdkUserInfo)
        else
            self:login()
        end
    else
        CQuickSDK.Init(self.listenCallBack, self)
    end
end

function QuickSDK:listenCallBack(msgType, data)
    if msgType == self.MsgType.InitSuccess then
        self:onInitSuccess()
    elseif msgType == self.MsgType.LoginSuccess then
        self:onLoginSuccess(data)
    elseif msgType == self.MsgType.LogoutSuccess then
        self:onLogoutSuccess()
    elseif msgType == self.MsgType.SwitchAccount then
        self:onSwitchAccountSuccess(data)
    end
end

function QuickSDK:login()
    CQuickSDK.Login()
end

function QuickSDK:logout()
    CQuickSDK.Logout()
end

function QuickSDK:createRole()
    local roleInfo = sdkMgr:getGameRoleInfo()
    CQuickSDK.CreateRole(roleInfo)
end

function QuickSDK:enterGame()
    local roleInfo = sdkMgr:getGameRoleInfo()
    CQuickSDK.EnterGame(roleInfo)
end

function QuickSDK:roleUpgrade()
    local roleInfo = sdkMgr:getGameRoleInfo()
    CQuickSDK.RoleUpgrade(roleInfo)
end

function QuickSDK:exitGame()
    if not CQuickSDK.IsChannelHasExitDialog() then
        
    end
end

--region 回调

function QuickSDK:onInitSuccess()
    self.isInited = true
    self:login()
    CGameUtil.GetPackageName()
end
--登录成功回调
function QuickSDK:onLoginSuccess(userInfo)
    gameDataManager.sdkUserInfo = userInfo
    uiMgr:getUI(_UIConfig.UILogin):channelLoginSuccess(
    {
    	channel_user_id = userInfo.uid,
    	channel_user_token = userInfo.token,
    	channel_code = CGameUtil.getStringFromMetaData("channelID"),
    	sub_channel_code = CGameUtil.getStringFromMetaData("subChannelID"),
	})
end
--登出成功回调
function QuickSDK:onLogoutSuccess()
    if levelMgr:getCurSceneName() == _ESceneName.Login then
        local uiData = uiMgr:getUI(_UIConfig.UICreateRole)
        if uiData ~= nil and uiData.uiState == _EUIState.Open then
            uiMgr:closeUIConfig(_UIConfig.UICreateRole)
        end
        self:login()
        return
    end
    channelLoginInfo = nil
    _gameTools.exitGame()
end
--切换帐号成功
function QuickSDK:onSwitchAccountSuccess(userInfo)
    gameDataManager.sdkUserInfo = userInfo
    gameDataManager.isLoggedIn = false
    channelLoginInfo = 
    {
    	channel_user_id = userInfo.uid,
    	channel_user_token = userInfo.token,
    	channel_code = CGameUtil.getStringFromMetaData("channelID"),
    	sub_channel_code = CGameUtil.getStringFromMetaData("subChannelID"),
	}
    if levelMgr:getCurSceneName() == _ESceneName.Login then
        local uiData = uiMgr:getUI(_UIConfig.UICreateRole)
        if uiData ~= nil and uiData.uiState == _EUIState.Open then
            uiMgr:closeUIConfig(_UIConfig.UICreateRole)
        end
        uiMgr:getUI(_UIConfig.UILogin):channelLoginSuccess(channelLoginInfo)
        return
    end
    sdkMgr.isSwitchAccount = true
    _gameTools.exitGame()
end

--endregion

--endregion
