--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"

UpltvSDK = Class()

function UpltvSDK:ctor()
    self.isInited = false

    self.MsgType = 
    {
        InitSuccess = "InitSuccess",
        AdDidClose = "AdDidClose",
        AdDidGiven = "AdDidGiven",
        AdDidAbandon = "AdDidAbandon",
        AdDidClick = "AdDidClick",
    }
end

function UpltvSDK:initSDK()
    Polymer.UPSDK.Init(self, self.listenCallBack)
    
    Polymer.UPSDK.initPolyAdSDK(0)
end

function UpltvSDK:listenCallBack(msgType, data)
    _gameTools.luaError("Edward:" .. msgType) 
    if msgType == self.MsgType.InitSuccess then
        self:onInitSuccess()
    elseif msgType == self.MsgType.AdDidGiven then
        self:onRewardDidGiven()
    elseif msgType == self.MsgType.AdDidAbandon then
        self:onRewardDidAbandon()
    elseif msgType == self.MsgType.AdDidClose then
        self:onRewardDidGiven()
    elseif msgType == self.MsgType.AdDidClick then
        self:onRewardDidClick()
    end
end

function UpltvSDK:onInitSuccess()
    self.isInited = true
    self:isAdReady()
--    Polymer.UPSDK.showRewardDebugView()
end

function UpltvSDK:showAd(opts)
    if self.isPlayingAd then
        _gameTools.luaError("Edward: ad is Playing ")
        return
    end

    if not self:isAdReady() then
        uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1088))
        _gameTools.luaError("Edward: ad is not read")
        return
    end

    self.isPlayingAd = true
    self.adOpts = opts
    local unitId = dataConfigMgr.getVideoPointNum(opts.unitId).videoPos
    Polymer.UPSDK.showRewardAd(unitId)
    local opts = {}
    opts.type = _DotType.WatchVideo
    opts.args = self.adOpts and self.adOpts.unitId or "0"
    sdkMgr:statisticsDot(opts)
end

function UpltvSDK:isAdReady()
    return Polymer.UPSDK.isRewardReady()
end

function UpltvSDK:onRewardDidGiven()
    if self.adOpts ~= nil then
        if self.adOpts.callBack ~= nil then
            if self.adOpts.objectTable ~= nil then
                self.adOpts.callBack(self.adOpts.objectTable, true)
            else
                self.adOpts.callBack(true)
            end
            sdkMgr:addVideoPointNum(self.adOpts.unitId)

            local opts = {}
            opts.type = _DotType.WatchVideoSuccess
            opts.args = self.adOpts and self.adOpts.unitId or "0"
            sdkMgr:statisticsDot(opts)
        end
    end
    self.adOpts = nil
    self.isPlayingAd = false
--    self:isAdReady()
end

function UpltvSDK:onRewardDidClick()
    local opts = {}
    opts.type = _DotType.VideoClick
    opts.args = self.adOpts and tostring(self.adOpts.unitId) or "0"
    sdkMgr:statisticsDot(opts)
end

function UpltvSDK:onRewardDidAbandon()
    if self.adOpts ~= nil then
        local opts = {}
        opts.type = _DotType.WatchVideoFail
        opts.args = self.adOpts and self.adOpts.unitId or "0"
        sdkMgr:statisticsDot(opts)
    end
    self.adOpts = nil
    self.isPlayingAd = false
--    self:isAdReady()
end

function UpltvSDK:onRewardDidClose()
    self.adOpts = nil
    self.isPlayingAd = false
--    self:isAdReady()
end


--endregion
