
require "ui/uiBase"

UIBattleResult = Class(UIBase)

function UIBattleResult:ctor()
    
end

function UIBattleResult:start(args)
	self.txtStage = self:getCom("content/stageBg/txtStage", _UICom.Text)
    self.txtMoney = self:getCom("content/txtMoney", _UICom.Text)
    self.successNode = self:getObj("content/success")
    self.defaultNode = self:getObj("content/default")
    self.victoryBg = self:getObj("content/success/bg")
    self.victoryStep1 = self:getObj("content/success/step1")
    self.victoryLeft = self:getObj("content/success/leftBg")
    self.victoryRight = self:getObj("content/success/rightBg")
    self.victoryLineBg = self:getObj("content/success/lineBg")
    self.victoryIcon = self:getObj("content/success/victory")
    self.victoryStep2 = self:getObj("content/success/resultPic")
    self.victoryCircle = self:getObj("content/success/circle")

    self.tipsText = self:getCom("content/tips/text",_UICom.Text)
    self.videoBtnText = self:getCom("content/videoBtn/text",_UICom.Text)
    self.getBtnText = self:getCom("content/getBtn/text",_UICom.Text)
    self.defaultTopBg = self:getObj("content/default/topBg")
    self.defaultPic = self:getObj("content/default/resultPic")
    self.defaultLeftBg = self:getObj("content/default/leftBg")
    self.defaultRightBg = self:getObj("content/default/rightBg")
    self.defaultIcon = self:getObj("content/default/default")
    self.defaultLine = self:getObj("content/default/lineBg")
    self.defaultCircle = self:getObj("content/default/circle")

    self:addClickByPath("content/getBtn", self.onGetBtnClick)
    self:addClickByPath("content/videoBtn", self.onVideoBtnClick)

    self.isWin = args
    self.awardGold = 0
    self.victoryIndex = 0
    self.defaultIndex = 0
    self.randomPosTime = 0
    self.isStart = false
    self.victoryArr = {}
    self.defaultArr = {}
    self:getChildNodeArr()
    self:init()
    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self)
end

function UIBattleResult:init()
    if battleMgr.levelId == 1 then
        _gameTools.eventDot(6)
    end

    self.txtStage.text = string.format(dataConfigMgr.getLanguage(1017),battleMgr.levelId)
    self.videoBtnText.text = dataConfigMgr.getLanguage(1019)
    self.getBtnText.text = dataConfigMgr.getLanguage(1020)
    self.tipsText.text = dataConfigMgr.getLanguage(1018)

    self.successNode:SetActive(false)
    self.defaultNode:SetActive(false)
    if self.isWin then
        self.successNode:SetActive(true)
        self:victoryAnim()
        self.awardGold = gameDataManager.victoryGetGold()
        gameDataManager.useVigor()
        gameDataManager.setFreeGunBtnState(true)
        eventMgr:broadcastEvent(_EventType.RefreshTargetTask, false)
    else
        self.defaultNode:SetActive(true)
        self:defaultAnim()
        self.awardGold = gameDataManager.defaultGetGold()
    end
    self.txtMoney.text = _gameTools.convertNumberToLabelString(self.awardGold)
end

function UIBattleResult:onGetBtnClick()
    self:closeSelf()
    _gameTools.removeUpdate(self.updateHandler)
    levelMgr:changeScene(_ESceneName.MainCity)
    gameDataManager.addGold(self.awardGold)

    gameDataManager.saveData()

    if battleMgr.levelId == 1 then
        _gameTools.eventDot(7)
    end
end

function UIBattleResult:onVideoBtnClick()
    local opts = {}
    opts.unitId = 9
    opts.objectTable = self
    opts.callBack = self.onVideoCallBack
    sdkMgr:showAd(opts)
end

function UIBattleResult:onVideoCallBack(result)
    if result then
        self:closeSelf()
        _gameTools.removeUpdate(self.updateHandler)
        levelMgr:changeScene(_ESceneName.MainCity)
        gameDataManager.addGold(self.awardGold * 3)
        gameDataManager.saveData()

        if battleMgr.levelId == 1 then
            _gameTools.eventDot(7)
        end
    end
end

--胜利的动画
function UIBattleResult:victoryAnim()
    audioMgr:playSound("win")
    _DoTweenHelper:Move(self.victoryStep1, Vector3.New(0, 0, 0), Ease.Linear, 0.1, function ()
        self.victoryStep2:SetActive(true)
        _DoTweenHelper:Move(self.victoryStep2, Vector3.New(2.5, 238, 0), Ease.Linear, 0.1, function ()
            self.isStart = true
            _DoTweenHelper:FadeIn(self.victoryBg, 4)
            _DoTweenHelper:FadeIn(self.victoryCircle, 4)
            _DoTweenHelper:FadeIn(self.victoryLineBg, 2)
            _DoTweenHelper:FadeIn(self.victoryIcon, 2)
            _DoTweenHelper:FadeIn(self.victoryLeft, 2)
            _DoTweenHelper:FadeIn(self.victoryRight, 2)
            _DoTweenHelper:Move(self.victoryLeft, Vector3.New(-97, 220, 0), Ease.Linear, 2, nil)
            _DoTweenHelper:Move(self.victoryRight, Vector3.New(97, 220, 0), Ease.Linear, 2, nil)
        end)
    end)
end

--失败的动画
function UIBattleResult:defaultAnim()
    audioMgr:playSound("default")
    _DoTweenHelper:Move(self.defaultTopBg, Vector3.New(0, 257, 0), Ease.Linear, 0.1, function ()
        self.defaultPic:SetActive(true)
        _DoTweenHelper:Move(self.defaultPic, Vector3.New(-2, 249, 0), Ease.Linear, 0.1, function ()
            self.isStart = true
            _DoTweenHelper:FadeIn(self.defaultLeftBg, 1)
            _DoTweenHelper:FadeIn(self.defaultRightBg, 1)
            _DoTweenHelper:FadeIn(self.defaultLine, 1)
            _DoTweenHelper:FadeIn(self.defaultIcon, 1)
            self.defaultLeftBg.transform:Rotate(-Vector3.forward * 1,18)
            self.defaultRightBg.transform:Rotate(Vector3.forward * 1,18)
            _DoTweenHelper:Move(self.defaultLeftBg, Vector3.New(66, 238, 0), Ease.Linear, 1.5, nil)
            _DoTweenHelper:Move(self.defaultRightBg, Vector3.New(-66, 238, 0), Ease.Linear, 1.5, nil)
            _DoTweenHelper:FadeIn(self.defaultCircle, 2)
        end)
    end)
end

function UIBattleResult:onUpdate()
    self:randomVictoryPos()
    self:randomDefaultPos()
end

function UIBattleResult:getChildNodeArr()
    for i =1,self.victoryCircle.transform.childCount do
        self.victoryArr[i] = self.victoryCircle.transform:GetChild(i - 1)
    end
     for i =1,self.defaultCircle.transform.childCount do
        self.defaultArr[i] = self.defaultCircle.transform:GetChild(i - 1)
    end
end

--胜利生成圆点随机出现
function UIBattleResult:randomVictoryPos()
    if self.isStart and self.isWin then
        self.randomPosTime = self.randomPosTime + Time.deltaTime
        self.victoryBg.transform:Rotate(-Vector3.forward * 1)
        if self.randomPosTime >= 0.1 then            
            self.victoryIndex = self.victoryIndex + 1
            if self.victoryIndex >= 7 then
                self.victoryIndex = 1
            end
            local x = self.victoryArr[self.victoryIndex].localPosition.x + ( math.random() - 0.5 ) * 210
            local y = self.victoryArr[self.victoryIndex].localPosition.y + ( math.random() - 0.5 ) * 185
            local tmpx = x > 0 and 1 or -1
            local tmpy = y > 0 and 1 or -1
            if math.abs(x) > 210 then
                x = math.random() * 210 * tmpx
            end
            if math.abs(y) > 185 then
                y = math.random() * 185 * tmpy
            end
            self.victoryArr[self.victoryIndex].localPosition = Vector3(x,y,0)
            self.randomPosTime = 0
        end
    end
end

--失败生成圆点随机出现
function UIBattleResult:randomDefaultPos()
    if self.isStart and self.isWin ~= true then
        self.randomPosTime = self.randomPosTime + Time.deltaTime
        if self.randomPosTime >= 0.1 then
            self.defaultIndex = self.defaultIndex + 1
            if self.defaultIndex >= 8 then
                self.defaultIndex = 1
            end
            local x = self.defaultArr[self.defaultIndex].localPosition.x + ( math.random() - 0.5 ) * 175
            local y = self.defaultArr[self.defaultIndex].localPosition.y + ( math.random() - 0.5 ) * 175
            local tmpx = x > 0 and 1 or -1
            local tmpy = y > 0 and 1 or -1
            if math.abs(x) > 175 then
                x = math.random() * 175 * tmpx
            end
            if math.abs(y) > 175 then
                y = math.random() * 175 * tmpy
            end
            self.defaultArr[self.defaultIndex].localPosition = Vector3(x,y,0)
            self.randomPosTime = 0
        end
    end
end

return UIBattleResult