--region 加载界面
--Date
--此文件由[BabeLua]插件自动生成
require "ui/uiBase"

UIDial = Class(UIBase)

function UIDial:start()
	self:addClickByPath("content/closeBtn", self.onCloseBtn) 
	self:addClickByPath("content/getTicketBtn", self.onGetTicketBtn) 
	self:addClickByPath("content/startBtn", self.onStartBtn) 
	self:addClickByPath("content/awardPanel/content/getBtn", self.onGetBtn) 
	self:addClickByPath("content/awardPanel/content/videoBtn", self.onVideoBtn) 
    self:addClickByPath("content/awardTicket/content/videoBtn", self.onVideoTicketBtn)
    self:addClickByPath("content/awardTicket/content/closeBtn", self.onCloseTicketBtn)

    self.dialAwardObj = self:getObj("content/dialBg")
    self.content = self:getObj("content")
    self.ticketNum = self:getCom("content/tips",_UICom.Text)
    self.awardPanelTitle = self:getCom("content/awardPanel/content/title/text", _UICom.Text)
    self.awardTicketTips = self:getCom("content/awardTicket/content/tips", _UICom.Text)
    self.getTicketBtn = self:getObj("content/getTicketBtn")
    self.awardPanel = self:getObj("content/awardPanel")
    self.awardPanelIcon = self:getCom("content/awardPanel/content/icon", _UICom.Image)
    self.awardTicket = self:getObj("content/awardTicket")
    self.awardLight = self:getObj("content/awardPanel/content/bg")
    self.horseLampRed = self:getObj("content/horseLamp/red")
    self.horseLampBlue = self:getObj("content/horseLamp/blue")
    self.awardPanelContent = self:getObj("content/awardPanel/content")
    self.flyPos = self:getObj("content/fly")
    self.awardPanelVideoBtn = self:getObj("content/awardPanel/content/videoBtn")
    self.awardName = self:getCom("content/awardPanel/content/tips",_UICom.Text)
    self.awardPic = self:getCom("content/awardPanel/content/awardIcon",_UICom.Image)
    self.startBtnText = self:getCom("content/startBtn/text",_UICom.Text)
    self.videoBtnText = self:getCom("content/awardPanel/content/videoBtn/name",_UICom.Text)
    self.getBtnText = self:getCom("content/awardPanel/content/getBtn/name",_UICom.Text)
    
    _gameTools.popupShowAnim(self.content)
    self:dialPanelInit()
    self:addAwardToList()
    self:bindAwardData()    
    self:bindDialPanel()    
    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self) 
end

--关闭转盘界面
function UIDial:onCloseBtn()
    if self.dialState ~= 1 then
        return
    end
    self:closeSelf()
    uiMgr:getUI(_UI.Main):refreshDialRedPoint()
end

--界面初始化
function UIDial:dialPanelInit()
    --配置表
    self.dialAwardCfg = _globalCfg.dialAward

    --转盘奖励
    self.awardIndex = 0
    self.awardNum = 0

    --跑马灯
    self.horseLampTime = 1
    self.horseLampIndex = 0
    self.redList = {}
    self.blueList = {}
    for i =1,self.horseLampRed.transform.childCount do
        self.redList[i] = self.horseLampRed.transform:GetChild(i - 1)
        self.blueList[i] = self.horseLampBlue.transform:GetChild(i - 1)
    end

    --转盘开始抽奖初始化
    self:dialInit()

    --转盘奖励界面
    self.isStartRotate = false
    self.awardObjList = {}
    self.calGetAwardList = {}
    for i = 1,self.dialAwardObj.transform.childCount do
        self.awardObjList[i] = self.dialAwardObj.transform:GetChild(i - 1)
    end

    --文本
    self.awardTicketTips.text = string.format(dataConfigMgr.getLanguage(1079), _globalCfg.ticketNum)
    self.awardPanelTitle.text = dataConfigMgr.getLanguage(1072)
end

--转盘奖励界面光圈转动
function UIDial:lightRotateAnim()
    if self.isStartRotate then
        self.awardLight.transform:Rotate(-Vector3.forward * 1)
    end
end

--抽奖播放转盘的动画
function UIDial:dialAnim()
    if self.dialState == 1 then
        return
    end
    self._time = self._time + Time.deltaTime
    if self.dialState == 4 then
        local k = 1
        self._tmpAngle = Mathf.Lerp(self._tmpAngle, self.EndAngle, Time.deltaTime * k)
        self._tmpAngle = self._tmpAngle < 0 and self._tmpAngle or self._tmpAngle
        self.dialAwardObj.transform.rotation = Quaternion.Euler(0, 0, self._tmpAngle)
        if 1 >= math.abs(self._tmpAngle - self.EndAngle) then
            self.isStartRotate = true
            self.dialState = 1
            self.awardPanel:SetActive(true)
            self:bindShowAwardPanel()
            _gameTools.popupShowAnim(self.awardPanelContent)
            uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1051))
        end
    else
        self._factor = self._time / self.AcceleateTime
        if self._factor >= 1 then
            self._factor = 1
        end
        self.dialAwardObj.transform:Rotate(Vector3.back, self._factor * self.velocity * 0.01)
    end

    if self.dialState == 3 and self._time > self._minTime then                  
        self.dialState = 4
        self._tmpAngle = self:GetCurClockwiseAngle()
    end
end

function UIDial:GetCurClockwiseAngle()
    return -1 * (360 - self.dialAwardObj.transform.eulerAngles.z) % 360
end

--点击开始抽奖按钮
function UIDial:onStartBtn()
    if self.dialState ~= 1 then
        return
    end
    if gameDataManager.useTicket() then
        self.dialState = 2
        self:getRandomIndex()
        self._time = 0
        self.awardNum = self.calGetAwardList[self.awardIndex]
    else
        --奖券不足
        uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1078))
    end
    self:bindDialPanel()
end

--跑马灯动画
function UIDial:horseLampAnim()
    self.horseLampTime = self.horseLampTime + Time.deltaTime
    if self.horseLampTime >= 1 then
        self.horseLampTime = 0
        self.horseLampIndex = self.horseLampIndex + 1
        local tmp = self.horseLampIndex % 2 + 1 == 1 and true or false
        for i = 1,#self.redList do
            self.redList[i].gameObject:SetActive(tmp) 
            self.blueList[i].gameObject:SetActive(not tmp) 
        end
    end 
end

--播放飞行动画
function UIDial:playFlyAnim(args)
    if args == 1 then
        for i = 1,15 do
            local x,y = ( math.random() - 0.5) * 300, ( math.random() - 0.5) * 250
            uiMgr:getUI(_UI.FloatTips):showGoldFly(Vector3(x,y,0), Vector3(0,0,0), uiMgr:getUI(_UI.Main).goldIcon, self.flyPos.transform)
        end
    else
        for i = 1,15 do
            local x,y = ( math.random() - 0.5) * 300, ( math.random() - 0.5) * 250
            uiMgr:getUI(_UI.FloatTips):showDiamondFly(Vector3(x,y,0), Vector3(0,0,0), uiMgr:getUI(_UI.Main).diamondIcon, self.flyPos.transform)
        end
    end
end


--获取一个角度
function UIDial:getRandomIndex()
    self.awardIndex = _gameTools.randomAward(self.dialAwardCfg)
    self.EndAngle = (self.awardIndex - 1) * 45 - 360
    self.dialState = 3
end

--点击获取奖券按钮
function UIDial:onGetTicketBtn()
    if self.dialState ~= 1 then
        return
    end
    self.awardTicket:SetActive(true)
end

--点击视频按钮领取奖券
function UIDial:onVideoTicketBtn()
    if not sdkMgr:getVideoPointIsUseUp(21) then
        local opts = {}
        opts.unitId = 21
        opts.objectTable = self
        opts.callBack = self.onVideoGetTIcketCallBack
        sdkMgr:showAd(opts) 
    else
        uiMgr:openUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1086))
    end
end

function UIDial:onVideoGetTIcketCallBack(result)
    if result then
        self.awardTicket:SetActive(false)
        gameDataManager.addTicket(4)
        self:bindDialPanel()
    end
end

--点击关闭视频领取奖券界面
function UIDial:onCloseTicketBtn()
    self.awardTicket:SetActive(false)
end

--绑定转盘界面的信息
function UIDial:bindDialPanel()
    local tmpNum = gameDataManager.getTicket()
    self.startBtnText.text = dataConfigMgr.getLanguage(1028)
    self.ticketNum.text = dataConfigMgr.getLanguage(1027)..": "..tmpNum
    self.getTicketBtn:SetActive(true)
    self.awardPanel:SetActive(false)
end

--绑定转盘界面奖励信息
function UIDial:bindAwardData()
    for i = 1,#self.awardObjList do
        local name = self:getCom("name",_UICom.Text,self.awardObjList[i].gameObject)
        local icon = self.awardObjList[i].gameObject:GetComponent(_UICom.Image)
        name.text = _gameTools.convertNumberToLabelString(self.calGetAwardList[i])
        if self.dialAwardCfg[i][2] == 1 then
            --金币
            icon.sprite = self:loadObject("atlas_common", "jinbi")
        elseif self.dialAwardCfg[i][2] == 2 then
            --钻石
            icon.sprite = self:loadObject("atlas_common", "zuanshi")
        elseif self.dialAwardCfg[i][2] == 4 then
            --体力
            icon.sprite = self:loadObject("atlas_common", "tili")
        end
        icon:SetNativeSize()
    end
end


function UIDial:onUpdate()
    self:dialAnim()
    self:horseLampAnim()
    self:lightRotateAnim()
end

function UIDial:onClear()
    _gameTools.removeUpdate(self.updateHandler)
end

--转盘开始的初始化
function UIDial:dialInit()
--    self.dialState = 
--    {
--        None = 1,       --待机状态
--        Start = 2,      --加速阶段
--        Prepared = 3,   --等待数据阶段
--        End = 4,        --减速阶段
--    }
    self.velocity = 3000    --最大的速度
    self._endAngle = 0      --最终停止角度
    self.AcceleateTime = 4  --加速持续时间
    self._minTime = 4       --减速前的最短持续时间
    self._tmpAngle = 0      --角度缓存
    self._time = 0          --统计时间
    self._factor = 0        --加速度
    self.dialState = 1
end

--计算出转盘的奖励添加到列表中
function UIDial:addAwardToList()
    for i = 1,#self.dialAwardCfg do
        if self.dialAwardCfg[i][2] == 1 then
            local lv = gameDataManager.getCurGunLv()
            local gold = gameDataManager.calExpendGoldNum(lv)
            self.calGetAwardList[i] =  math.floor(gold * self.dialAwardCfg[i][3])
        elseif self.dialAwardCfg[i][2] == 2 then
            self.calGetAwardList[i] = self.dialAwardCfg[i][3]
        elseif self.dialAwardCfg[i][2] == 4 then
            self.calGetAwardList[i] = self.dialAwardCfg[i][3]
        end
    end
end

--添加奖励
function UIDial:addAward(double)
    local index = self.awardIndex
    local dialCfg = self.dialAwardCfg
    if dialCfg[index][2] == 1 then
        gameDataManager.addGold(self.awardNum * double)
    elseif dialCfg[index][2] == 2 then
       gameDataManager.addDiamond(self.awardNum * double)
    elseif dialCfg[index][2] == 3 then        
        uiMgr:getUI(_UI.Main):addFirearmsToBag(self.awardNum, false)   
    elseif dialCfg[index][2] == 4 then        
        gameDataManager.addVigor(self.awardNum * double,true)    
    end
end

--普通领取
function UIDial:onGetBtn()
    self:addAward(1)
    self.awardPanel:SetActive(false)
    self.isStartRotate = false
    local tmp = self.dialAwardCfg[self.awardIndex][2]
    if tmp == 1 or tmp == 2 then
        self:playFlyAnim(tmp)
    end    
    eventMgr:broadcastEvent(_EventType.RefreshVigorAndGameLv, false)
end

--视频领取
function UIDial:onVideoBtn()
    local opts = {}
    opts.unitId = 22
    opts.objectTable = self
    opts.callBack = self.onVideoGetCallBack
    sdkMgr:showAd(opts)    
end
function UIDial:onVideoGetCallBack(result)
    if result then
        self:addAward(2)
        self.awardPanel:SetActive(false)
        local tmp = self.dialAwardCfg[self.awardIndex][2]
        if tmp == 1 or tmp == 2 then
            self:playFlyAnim(tmp)
        end
        eventMgr:broadcastEvent(_EventType.RefreshVigorAndGameLv, false)
    end
end

--绑定显示获得奖励的信息
function UIDial:bindShowAwardPanel()    
    local index = self.awardIndex
    local dialCfg = self.dialAwardCfg
    if dialCfg[index][2] == 1 then
        self.awardName.text = _gameTools.convertNumberToLabelString(self.awardNum)
        self.awardPic.sprite = self:loadObject("atlas_common", "jinbi")
        self.awardPanelIcon.sprite = self:loadObject("atlas_common", "jinbi")        
    elseif dialCfg[index][2] == 2 then
        self.awardName.text = self.awardNum
        self.awardPic.sprite = self:loadObject("atlas_common", "zuanshi")
        self.awardPanelIcon.sprite = self:loadObject("atlas_common", "zuanshi")
    elseif dialCfg[index][2] == 3 then
        self.awardPic.sprite = self:loadObject("atlas_gunIcon", dataConfigMgr.getFirearms(self.awardNum).icon)
        self.awardName.text = dataConfigMgr.getFirearms(self.awardNum).name
        self.awardPanelIcon.gameObject:SetActive(false)
    elseif dialCfg[index][2] == 4 then
        self.awardName.text = self.awardNum
        self.awardPic.sprite = self:loadObject("atlas_common", "tili")
        self.awardPanelIcon.sprite = self:loadObject("atlas_common", "tili")
    end
    self.awardPanelIcon:SetNativeSize()
    self.awardPic:SetNativeSize()
    self.videoBtnText.text = dataConfigMgr.getLanguage(1022)
    self.getBtnText.text = dataConfigMgr.getLanguage(1024)
    self.awardPanelVideoBtn:SetActive(not sdkMgr:getVideoPointIsUseUp(22))
end

return UIDial
--endregion