
require "ui/uiBase"

UIFloatTips = Class(UIBase)

function UIFloatTips:ctor()

end

function UIFloatTips:start()
	self.flyTipsPrefab = self:getObj("content/flyTipsPrefab")
    self.textBoxPrefab1 = self:getObj("content/textBoxPrefab1")
    self.flyTipsRoot = self:getObj("content/flyTipsRoot")
    self.diamondPrefab = self:getObj("content/diamond")
    self.blockPrefab = self:getObj("content/block")
    self.goldPrefab = self:getObj("content/gold")
    self.getAwardTips = self:getObj("content/getTips")
    self.goldBoxPrefab = self:getObj("content/goldBox")
    self.starItemPrefab = self:getObj("content/starItem")
    self.freeUpGunPrefab = self:getObj("content/freeUpGun")
    self.getAwardTipsText = self:getCom("content/getTips/text",_UICom.Text)

    self.flyTipsList = {}
    self.textBox1List = {}
    self.diamondFlyList = {}
    self.goldFlyList = {}
    self.blockList = {}
    self.goldBoxBlockList = {}
    self.starItemList = {}
    self.freeUpGunList = {}
    self.isStart = false
end

function UIFloatTips:showProductMoney(pos, moneyNum, parent)
    local flyTipsItem = self:getFlyTips()
    flyTipsItem.gameObject:SetActive(true)
    moneyNum = _gameTools.convertNumberToLabelString(moneyNum)
    flyTipsItem.text = "+$"..moneyNum
    if parent then
        flyTipsItem.transform:SetParent(parent)
        pos = parent:InverseTransformPoint(pos)        
        flyTipsItem.transform.localPosition = pos
    else
        pos = flyTipsItem.transform.parent:InverseTransformPoint(pos)       
        flyTipsItem.transform.localPosition = pos
    end
    _DoTweenHelper:Move(flyTipsItem.gameObject, Vector3(pos.x,pos.y + 60,pos.z), Ease.Linear, 0.7, function()
        self:recoveryFlyTips(flyTipsItem)
    end)
end
function UIFloatTips:getFlyTips()
    if #self.flyTipsList > 0 then
        return table.remove(self.flyTipsList, 1)
    else
        local tipsItem = GameObject.Instantiate(self.flyTipsPrefab)
        tipsItem.transform:SetParent(self.flyTipsRoot.transform)
        return tipsItem:GetComponent(_UICom.Text)
    end
end
function UIFloatTips:recoveryFlyTips(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.flyTipsList, item)
end

--ıʾȡɹ
function UIFloatTips:shwoGetAwardTipsAnim(args)
    if self.isStart then
        return
    end
    self.isStart = true
    self.getAwardTipsText.text = args
    self.getAwardTips:SetActive(true)
    _DoTweenHelper:Move(self.getAwardTips, Vector3.New(0,150,0), Ease.Linear, 1, function()
        self.getAwardTips:SetActive(false)
        self.getAwardTips.transform.localPosition = Vector3.zero
        self.isStart = false
    end)
end

--ʯж
function UIFloatTips:showDiamondFly(pos, centerPos, endObj, parent)
    local item = self:getDiamondFly()
    item:SetActive(true)   
    local endPos
    if parent then
        item.transform:SetParent(parent)        
        item.transform.localPosition = centerPos
        endPos = parent:InverseTransformPoint(endObj.transform.position)
    else
        pos = item.transform.parent:InverseTransformPoint(pos)
        item.transform.localPosition = pos
        endPos = item.transform.parent:InverseTransformPoint(endObj.transform.position)
    end        
    _DoTweenHelper:Move(item.gameObject, pos, Ease.Linear, 0.4, function()        
        _DoTweenHelper:Move(item.gameObject, endPos, Ease.Linear, math.random(), function()
            self:recoveryDiamondFly(item)
        end)
    end)
end

function UIFloatTips:getDiamondFly()
    if #self.diamondFlyList > 0 then
        return table.remove(self.diamondFlyList, 1)        
    else
        local item = GameObject.Instantiate(self.diamondPrefab)
        item.transform:SetParent(self.flyTipsRoot.transform)
        return item
    end
end

function UIFloatTips:recoveryDiamondFly(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.diamondFlyList, item)
end


--ǹ֧Ǯʱ򲥷Ŷ
function UIFloatTips:showBlockFly(parent)
    local item = self:getBlock()
    item:SetActive(true)   
--    _DoTweenHelper:FadeIn(item, 0)
    item.transform:SetParent(parent)    
--    item.transform.localPosition = Vector3.zero
    self:oneBlockAnim(item)
end

--ж
function UIFloatTips:oneBlockAnim(item)
    item.transform.localPosition = Vector3(( math.random() - 0.5) * 50, - 50, 0)    
    _DoTweenHelper:Move(item, Vector3.New(( math.random() - 0.5) * 200, ( math.random() - 0.5) * 100 + 50, 0), Ease.Linear, math.random() * 0.5 + 0.5, function()
        self:recoveryBlock(item)
    end)
end

function UIFloatTips:getBlock()
    if #self.blockList > 0 then
        return table.remove(self.blockList, 1)        
    else
        local item = GameObject.Instantiate(self.blockPrefab)
        local wh = math.floor( math.random() * 5 + 10)
        item:GetComponent(_UICom.RectTransform).sizeDelta = Vector2(wh,wh)
        item:GetComponent(_UICom.Image).color =  Color(0.05, 0.83, 1, math.random() * 0.3 + 0.3)
        item.transform:SetParent(self.flyTipsRoot.transform)        
        return item
    end
end

function UIFloatTips:recoveryBlock(item)    
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.blockList, item)
end

--ҷж
function UIFloatTips:showGoldFly(pos, centerPos, endObj, parent)
    local item = self:getGoldFly()
    item:SetActive(true)   
    local endPos
    if parent then
        item.transform:SetParent(parent)
        item.transform.localPosition = centerPos
        endPos = parent:InverseTransformPoint(endObj.transform.position)
    else
        pos = item.transform.parent:InverseTransformPoint(pos)
        item.transform.localPosition = pos
        endPos = item.transform.parent:InverseTransformPoint(endObj.transform.position)
    end        
    _DoTweenHelper:Move(item.gameObject, pos, Ease.Linear, 0.4, function()        
        _DoTweenHelper:Move(item.gameObject, endPos, Ease.Linear, math.random(), function()
            self:recoveryGoldFly(item)
        end)
    end)
end

function UIFloatTips:getGoldFly()
    if #self.goldFlyList > 0 then
        return table.remove(self.goldFlyList, 1)        
    else
        local item = GameObject.Instantiate(self.goldPrefab)
        item.transform:SetParent(self.flyTipsRoot.transform)
        return item
    end
end

function UIFloatTips:recoveryGoldFly(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.goldFlyList, item)
end


--չʾıʾ
function UIFloatTips:showFadeText(pos, str, delay, parent)
    local item = self:getTextBox1()
    item.canvasGroup.alpha = 1
    item.obj:SetActive(true)
    item.label.text = str
    if parent then
        item.obj.transform:SetParent(parent)
        pos = parent:InverseTransformPoint(pos)
        item.obj.transform.localPosition = pos
    else
        pos = item.obj.transform.parent:InverseTransformPoint(pos)
        item.obj.transform.localPosition = pos
    end
    _DoTweenHelper:Move(item.obj, Vector3.New(0, pos.y, pos.z), Ease.Linear, 0.2, function()
        _DoTweenHelper:FadeGroup(item.obj, 0, 0.7, delay or 0, function()
            self:recoveryTextBox1(item)
        end)
    end)
    
end
function UIFloatTips:getTextBox1()
    if #self.textBox1List > 0 then
        return table.remove(self.textBox1List, 1)
    else
        local tipsItem = GameObject.Instantiate(self.textBoxPrefab1)
        tipsItem.transform:SetParent(self.flyTipsRoot.transform)
        local item = {}
        item.obj = tipsItem
        item.canvasGroup = tipsItem:GetComponent(_UICom.CanvasGroup)
        item.label = tipsItem.transform:Find("text"):GetComponent(_UICom.Text)
        return item
    end
end
function UIFloatTips:recoveryTextBox1(item)
    item.obj.transform:SetParent(self.flyTipsRoot.transform)
    item.obj:SetActive(false)
    table.insert(self.textBox1List, item)
end


--涯
function UIFloatTips:goldBoxBlockAnim(parent)
    local item = self:getGoldBoxBlock()
    item:SetActive(true)   
    item.transform:SetParent(parent)
    item.transform.localPosition = Vector3(0,0,0)
    item.transform.localScale = Vector3.one
    self:goldBoxOneBlockAnim(item)
end

--ж
function UIFloatTips:goldBoxOneBlockAnim(item)
    _DoTweenHelper:Move(item, Vector3.New(( math.random() - 0.5) * 260, ( math.random() - 0.5) * 260, 0), Ease.Linear, math.random() * 1.2 + 0.8, function()
        self:recoveryGoldBoxBlock(item)
    end)
end

function UIFloatTips:getGoldBoxBlock()
    if #self.goldBoxBlockList > 0 then
        return table.remove(self.goldBoxBlockList, 1)        
    else
        local item = GameObject.Instantiate(self.goldBoxPrefab)
        local wh = math.floor( math.random() * 35 + 15)
        item:GetComponent(_UICom.RectTransform).sizeDelta = Vector2(wh,wh)
        item:GetComponent(_UICom.Image).color = Color(1,1,1, math.random() * 0.3 + 0.3)
        item.transform:SetParent(self.flyTipsRoot.transform)
        return item
    end
end

function UIFloatTips:recoveryGoldBoxBlock(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.goldBoxBlockList, item)
end

--ǹе涯
function UIFloatTips:freeUpGunAnim(parent)
    local item = self:getFreeUpGun()
    item:SetActive(true)   
    item.transform:SetParent(parent)
    item.transform.localPosition = Vector3(( math.random() - 0.5) * 50, ( math.random() - 0.5) * 50, 0)
    self:oneFreeUpGunAnim(item)
end

--ǹе浥
function UIFloatTips:oneFreeUpGunAnim(item)
    _DoTweenHelper:Move(item, Vector3.New(( math.random() - 0.5) * 340, ( math.random() - 0.5) * 200, 0), Ease.Linear, math.random() * 0.8 + 0.8, function()
        self:recoveryFreeUpGun(item)
    end)
end

function UIFloatTips:getFreeUpGun()
    if #self.freeUpGunList > 0 then
        return table.remove(self.freeUpGunList, 1)        
    else
        local item = GameObject.Instantiate(self.freeUpGunPrefab)
        local wh = math.floor( math.random() * 54 + 20)
        item:GetComponent(_UICom.RectTransform).sizeDelta = Vector2(wh,wh)
        item:GetComponent(_UICom.Image).color = Color(1,1,1, math.random() * 0.4 + 0.5)
        item.transform:SetParent(self.flyTipsRoot.transform)
        return item
    end
end

function UIFloatTips:recoveryFreeUpGun(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.freeUpGunList, item)
end

--region perfect
--perfect
function UIFloatTips:playStarAnima(parent, pos, dir)
    local item = self:getStarItem()
    item:SetActive(true)   
    item.transform:SetParent(parent)
    item.transform.localPosition = pos or Vector3(0,0,0)
    item.transform.localScale = Vector3.one
    self:doStarAnima(item, dir)
end
--
function UIFloatTips:doStarAnima(item, dir)
    dir = dir or Vector3.New((math.random() - 0.5) * 260, ( math.random() - 0.5) * 200, 0)
    _DoTweenHelper:Move(item, dir, Ease.Linear, math.random() * 0.3 + 0.3, function()
        self:recoveryStarItem(item)
    end)
end
function UIFloatTips:getStarItem()
    if #self.starItemList > 0 then
        return table.remove(self.starItemList, 1)        
    else
        local item = GameObject.Instantiate(self.starItemPrefab)
--        local wh = math.floor( math.random() * 35 + 15)
--        item:GetComponent(_UICom.RectTransform).sizeDelta = Vector2(wh,wh)
--        item:GetComponent(_UICom.Image).color = Color(1,1,1, 1)
        item.transform:SetParent(self.flyTipsRoot.transform)
        return item
    end
end
function UIFloatTips:recoveryStarItem(item)
    item.transform:SetParent(self.flyTipsRoot.transform)
    item.gameObject:SetActive(false)
    table.insert(self.starItemList, item)
end
--endregion


return UIFloatTipsg