--region 加载界面
--Date
--此文件由[BabeLua]插件自动生成
require "ui/uiBase"

UIGameSet = Class(UIBase)

function UIGameSet:start()
	self:addClickByPath("content/closeBtn", self.onCloseBtn) 
	self:addClickByPath("content/slideSpeed/addBtn", self.addSpeed) 
	self:addClickByPath("content/slideSpeed/cutBtn", self.cutSpeed) 
	self:addClickByPath("content/slideSpeed/resetBtn", self.resetSpeed) 
    self.musicStateObj = self:getObj("content/music/toggle")
    self.soundStateObj = self:getObj("content/sound/toggle")
	self:addToggleValueChange(self.musicStateObj, self.onMusicBtn) 
	self:addToggleValueChange(self.soundStateObj, self.onSoundBtn) 
    self:addClickByPath("content/guideMask/click", self.onGuideMaskClick)
    self:addClickByPath("content/finsUsOn", self.onFindUsOnBtn)
    

    self.content = self:getObj("content")
    self.slideSpeedObj = self:getObj("content/slideSpeed")
    self.slideSpeed = self:getCom("content/slideSpeed/speed",_UICom.Text)
    self.musicState = self:getCom("content/music/toggle",_UICom.Toggle)
    self.soundState = self:getCom("content/sound/toggle",_UICom.Toggle)
    self.musicStateText = self:getCom("content/music/result",_UICom.Text)
    self.soundStateText = self:getCom("content/sound/result",_UICom.Text)

    self.guideMask = self:getObj("content/guideMask")
    self.txtGuideDesc = self:getCom("content/guideMask/bubbleImg/txtDesc", _UICom.Text)

    self.speedNum = gameDataManager.getSlideSpeed()
    self:bindGameSetPanel()
    _gameTools.popupShowAnim(self.content)
    self:initTxt()
end

function UIGameSet:initTxt()
    self.txtGuideDesc.text = dataConfigMgr.getLanguage(124)
end

--关闭游戏设置界面
function UIGameSet:onCloseBtn()
    gameDataManager.setSlideSpeed(self.speedNum)
    self:closeSelf()
end

--绑定设置界面信息
function UIGameSet:bindGameSetPanel()
    self.slideSpeed.text = self.speedNum
    self.musicState.isOn = gameDataManager.getMusicState()
    self.soundState.isOn = gameDataManager.getSoundState()
    self.musicStateText.text = self.musicState.isOn and "ON" or "OFF"
    self.soundStateText.text = self.soundState.isOn and "ON" or "OFF"
    if gameDataManager.guideData.isShowSettings == nil or gameDataManager.guideData.isShowSettings == 0 then
        gameDataManager.guideData.isShowSettings = 1
        _gameTools.eventDot(107)
        self.guideMask:SetActive(true)
        self.slideSpeedObj.transform:SetParent(self.guideMask.transform)
        self.slideSpeedObj.transform:SetAsFirstSibling()
    end
end

function UIGameSet:onGuideMaskClick()
    _gameTools.eventDot(108)
    self.guideMask:SetActive(false)
    self.slideSpeedObj.transform:SetParent(self.content.transform)
end

--增加滑动速度
function UIGameSet:addSpeed()
    if self.speedNum >= 30 then
        return
    end
    self.speedNum = self.speedNum + 1
    self.slideSpeed.text = self.speedNum
end

--降低滑动速度
function UIGameSet:cutSpeed()
    if self.speedNum <= 1 then
        return
    end
    self.speedNum = self.speedNum - 1
    self.slideSpeed.text = self.speedNum
end

--恢复默认速度
function UIGameSet:resetSpeed()
    self.slideSpeed.text = _globalCfg.slideSpeed
    self.speedNum = _globalCfg.slideSpeed
end

--点击设置音乐
function UIGameSet:onMusicBtn()
    local state = gameDataManager.getMusicState()
    gameDataManager.setMusicState(not state)
    self.musicStateText.text = not state and "ON" or "OFF"
    audioMgr:setMusicSwitch(not state)   
end

--点击设置音效
function UIGameSet:onSoundBtn()
    local state = gameDataManager.getSoundState()
    gameDataManager.setSoundState(not state)
    self.soundStateText.text = not state and "ON" or "OFF"
    audioMgr:setSoundSwitch(not state)
end

--发现我们
function UIGameSet:onFindUsOnBtn()
    Application.openURL(_globalCfg.gameSetURL)
end

return UIGameSet
--endregion