
require "ui/uiBase"

UIGuide = Class(UIBase)

function UIGuide:ctor()
    self.curGuideId = 0
    self.btnClickAfterCheckId = 0
end

function UIGuide:start()
    self.content = self:getObj("content")
    self.maskL = self:getCom("content/maskL", _UICom.RectTransform)
    self.maskR = self:getCom("content/maskR", _UICom.RectTransform)
    self.maskT = self:getCom("content/maskT", _UICom.RectTransform)
    self.maskB = self:getCom("content/maskB", _UICom.RectTransform)
    self.maskLImg = self:getCom("content/maskL", _UICom.Image)
    self.maskRImg = self:getCom("content/maskR", _UICom.Image)
    self.maskTImg = self:getCom("content/maskT", _UICom.Image)
    self.maskBImg = self:getCom("content/maskB", _UICom.Image)

--    self.fullClickObj = self:getObj("")
    self.finger = self:getCom("content/finger", _UICom.RectTransform)
    self.dialogNode = self:getObj("content/dialogObj")
    self.txtDialog = self:getCom("content/dialogObj/txt", _UICom.Text)

    self.curGuideId = 0

    self.content:SetActive(false)

    self:registerEvent(_EventType.GunMerge, self, self.gunBagMerge)
    self:registerEvent(_EventType.CacheGuide, self, self.cacheGuide)
    self:registerEvent(_EventType.CheckCacheGuide, self, self.checkCacheGuide)
--    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self)
end

--function UIGuide:onUpdate()

--end

--新手引导点击监听
function UIGuide:onButtonClickBef(uiInfo, go)
    if self.curGuideId == 0 then
        return
    end

    if self.startNode == nil then
        return
    end

    if go == self.startNode.gameObject then
        if self.curGuideId ~= 0 then
            local cfg = dataConfigMgr.getGuideCfg(self.curGuideId)
            self.btnClickAfterCheckId = cfg.nextId
        end
        self:finishGuide(self.curGuideId)
    end
end

function UIGuide:onButtonClickAft(uiInfo, go)
    if self.btnClickAfterCheckId ~= 0 then
        self:checkGuide(self.btnClickAfterCheckId)
        self.btnClickAfterCheckId = 0
    end
end

function UIGuide:finishGuide(id)
    local finishId = id or self.curGuideId
    if finishId == 0 then return end

    gameDataManager.finishGuide(id)
    
    self.content:SetActive(false)
    self.curGuideId = 0
    local cfg = dataConfigMgr.getGuideCfg(finishId)
    if cfg.eventDotId ~= 0 then
        _gameTools.eventDot(cfg.eventDotId)
    end
    if self.btnClickAfterCheckId == 0 and cfg.nextId ~= 0 then
        self:checkGuide(cfg.nextId)
    end
end

function UIGuide:checkGuide(id)
    if self.curGuideId ~= 0 then
        return
    end

    local isNeedGuide = not gameDataManager.isFinishGuide(id)
    if isNeedGuide and gameDef.GuideEnable then
        local cfg = dataConfigMgr.getGuideCfg(id)
        if cfg.lastId == 0 or (cfg.lastId ~= 0 and gameDataManager.isFinishGuide(cfg.lastId)) then
            self.curGuideId = id
            self:showGuide(id)
        end
    end
end

function UIGuide:showGuide(id)
    local cfg = dataConfigMgr.getGuideCfg(id)
    local topUI = uiMgr:getTopUI()
    if topUI.uiName ~= cfg.window then
        self.content:SetActive(false)
        gameDataManager.cacheGuideId = self.curGuideId
        self.curGuideId = 0
    end

    self.content:SetActive(true)
    self.maskL.gameObject:SetActive(false)
    self.maskR.gameObject:SetActive(false)
    self.maskT.gameObject:SetActive(false)
    self.maskB.gameObject:SetActive(false)

    self.startNode = nil
    self.endNode = nil
    self.dragFromId = 0
    self.dragToId = 0
    self.moveTime = 0.2
    local width = 0
    local height = 0

    if cfg.type == 1 then
        local uiInfo = uiMgr:getUI(cfg.window)
        if uiInfo.uiState == _EUIState.Open then
            self.startNode = self:getCom(cfg.nodePath1, _UICom.RectTransform, uiInfo.uiObject)
            self.endNode = self.startNode
            width = self.startNode.rect.width
            height = self.startNode.rect.height
        end
    elseif cfg.type == 2 then
        local obj1, obj2
        local uiInfo = uiMgr:getUI(cfg.window)
        if uiInfo.uiState == _EUIState.Open then
            for i = 1, gameDataManager.gunBagMaxCount do
                local data = gameDataManager.getBagDataById(i)
                if data ~= nil and data.level == cfg.value then
                    if obj1 == nil then
                        self.dragToId = i
                        obj1 = self:getCom(cfg.nodePath1..i, _UICom.RectTransform, uiInfo.uiObject) 
                    elseif obj2 == nil then
                        self.dragFromId = i
                        obj2 = self:getCom(cfg.nodePath2..i, _UICom.RectTransform, uiInfo.uiObject) 
                    end
                end
            end
            self.startNode = obj2
            self.endNode = obj1
        end
        self.moveTime = 0.5
    elseif cfg.type == 10 then
        local uiInfo = uiMgr:getUI(cfg.window)
        if uiInfo.uiState == _EUIState.Open then
            self.startNode = self:getCom(cfg.nodePath1, _UICom.RectTransform, uiInfo.uiObject)
            self.endNode = self.startNode
            width = self.startNode.rect.width
            height = self.startNode.rect.height
        end
    end

    if self.startNode == nil or self.endNode == nil then
        self.content:SetActive(false)
        return
    end

    if cfg.maskType == 1 then
        self.maskL.gameObject:SetActive(true)
        self.maskR.gameObject:SetActive(true)
        self.maskT.gameObject:SetActive(true)
        self.maskB.gameObject:SetActive(true)
        self:showMaskWithNode(self.startNode)
    elseif cfg.maskType == 2 then
        self.maskL.gameObject:SetActive(true)
        self.maskR.gameObject:SetActive(true)
        self.maskT.gameObject:SetActive(true)
        self.maskB.gameObject:SetActive(true)
        local maskPos = (self.startNode.position + self.endNode.position) * 0.5
        local maskHeight = math.abs(self.startNode.position.y - self.endNode.position.y) + self.startNode.sizeDelta.y * 0.5 + self.endNode.sizeDelta.y * 0.5
        local maskWidth = math.abs(self.startNode.position.x - self.endNode.position.x) + self.startNode.sizeDelta.x * gameDef.ResolutionScalerX * 0.5 + self.endNode.sizeDelta.x * 0.5 * gameDef.ResolutionScalerX
--        local uiInfo = uiMgr:getUI(cfg.window)
--        if uiInfo.uiState == _EUIState.Open then
--             local maskNode = self:getCom(cfg.maskNode, _UICom.RectTransform, uiInfo.uiObject)
            maskPos = self.content.transform:InverseTransformPoint(maskPos)
             self:showMaskWithPosAndWH(maskPos, maskWidth, maskHeight)
--        end
    elseif cfg.maskType == 3 then
        self.maskL.gameObject:SetActive(true)
        self.maskR.gameObject:SetActive(true)
        self.maskT.gameObject:SetActive(true)
        self.maskB.gameObject:SetActive(true)
    end

    if cfg.dialogLanId ~= 0 then
        self.dialogNode:SetActive(true)
        self.dialogNode.transform.position = self.startNode.position + Vector3(cfg.dialogPos[1], cfg.dialogPos[2] / gameDef.ResolutionScalerX, cfg.dialogPos[3])
        self.txtDialog.text = dataConfigMgr.getLanguage(cfg.dialogLanId)
    else
        self.dialogNode:SetActive(false)
    end

    self.finger.localEulerAngles = cfg.fingerRotate == 0 and Vector3(0,0,0) or Vector3(0,0,180)
    self:setGuideAnima(self.startNode, self.endNode)
end

function UIGuide:showMaskWithNode(rectTrans)
    local pos = self.content.transform:InverseTransformPoint(rectTrans.position)
    self:showMaskWithPosAndWH(pos, rectTrans.rect.width, rectTrans.rect.height)
end

function UIGuide:showMaskWithPosAndWH(pos, width, height)
    self.maskL.localPosition = pos - Vector3(width / 2,0,0)
    self.maskR.localPosition = pos + Vector3(width / 2,0,0)

    self.maskT.sizeDelta = Vector2(width, self.maskT.sizeDelta.y)
    self.maskT.localPosition = pos + Vector3(0,height / 2,0)

    self.maskB.sizeDelta = Vector2(width, self.maskB.sizeDelta.y)
    self.maskB.localPosition = pos - Vector3(0,height / 2,0)
end

function UIGuide:setGuideAnima(rectTrans1, rectTrans2)
    local startPos = rectTrans1.position
    local endPos = rectTrans2.position

    local dir = endPos - startPos
    self.finger.position = startPos
    self.finger.localScale = Vector3.one * 1.25

    if self.fingerTween ~= nil then
        self.fingerTween:Kill()
    end

    self.fingerTween = _DoTweenHelper:LoopTween(self.finger.gameObject, 0, 1.5, 1.5, 0, -1, LoopType.Restart, false, function(v)
        if v <= 0.2 then
            self.finger.position = startPos
            self.finger.localScale = Vector3.one * 1.25
        elseif v <= 0.3 then
            self.finger.localScale = Vector3.one * ((1 - (v - 0.2) / 0.1) * 0.15 + 0.85)
        elseif v <= 0.8 then
            self.finger.position = startPos + dir * (v - 0.3) / 0.5
        elseif v <= 0.9 then
            self.finger.localScale = Vector3.one * ((v - 0.8) / 0.1 * 0.4 + 0.85)
        elseif v <= 1.2 then
            
        else
            self.finger.position = startPos
            self.finger.localScale = Vector3.one * 1.25
        end
    end)
end

function UIGuide:gunBagMerge(params)
    if self.curGuideId == 0 then return end

    local fromId = params.fromId
    local toId = params.toId
    local level = params.level
    if (self.dragFromId == fromId and self.dragToId == toId) then
        self:finishGuide(self.curGuideId)
    end
end

-- 缓存引导
function UIGuide:cacheGuide()
    if self.curGuideId == 0 then
        return
    end

    local topUI = uiMgr:getTopUI()
    local cfg = dataConfigMgr.getGuideCfg(self.curGuideId)
    if topUI.uiName ~= cfg.window then
        self.content:SetActive(false)
        gameDataManager.cacheGuideId = self.curGuideId
        self.curGuideId = 0
    end
end

-- 检测缓存的引导
function UIGuide:checkCacheGuide()
    if gameDataManager.cacheGuideId == 0 then
        return
    end
    local topUI = uiMgr:getTopUI()
    local cfg = dataConfigMgr.getGuideCfg(gameDataManager.cacheGuideId)
    if topUI ~= nil and topUI.uiName == cfg.window then
        self.curGuideId = gameDataManager.cacheGuideId
        self:showGuide(self.curGuideId)
        gameDataManager.cacheGuideId = 0
    end
end

function UIGuide:onClear()
--    _gameTools.removeUpdate(self.updateHandler)
end

return UIGuide