--region 加载界面
--Date
--此文件由[BabeLua]插件自动生成

require "ui/uiBase"

UILoading = Class(UIBase)

function UILoading:ctor()
    
end

function UILoading:start(data)
    
    self.progressBar = self:getCom("content/Slider", _UICom.Slider)
    self.title = self:getCom("content/Slider/value", _UICom.Text)
    self.tips = self:getCom("content/tips", _UICom.Text)
    self.mapName = self:getCom("content/loadSence/mapName", _UICom.Text)
    self.mapIcon = self:getCom("content/loadSence/mapIcon",_UICom.Image)
    self.gameMask = self:getObj("gameMask")
    self.senceMask = self:getObj("senceMask")
    self.loadSence = self:getObj("content/loadSence")
    
    self.preLoadList = data[1] or {}
    self.loadType = data[2]
    self:registerEvent(_EventType.PreLoadCallBack, self, self.loadCompleted)
    self:init()
end

function UILoading:init()
    self.curProgress = 0
    self.progressBar.minValue = 0
    self.maxValue = #self.preLoadList
    self.progressBar.maxValue = self.maxValue
    self.progressBar.value = 0
    self.isOpenRandomTips = false    
    self.title.text = dataConfigMgr.getLanguage(1066)
    self.senceMask:SetActive(false)
    self.gameMask:SetActive(false)
    if self.loadType == 0 then
        self.senceMask:SetActive(true)
        self.randomTime = 0        
        self.mapName.text = dataConfigMgr.getLanguage(1063)..": "..dataConfigMgr.getBattleLevel(gameDataManager.getGameLv()).loadMapName
        self.mapIcon.sprite = self:loadLargeImg(dataConfigMgr.getBattleLevel(gameDataManager.getGameLv()).map)
        self.isOpenRandomTips = true
        self.loadSence:SetActive(true)
    else
        self.gameMask:SetActive(true)
    end
    self.tips.text = dataConfigMgr.getLanguage( math.floor( math.random() * 41) + 1)
    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self)
    self:loadUI()
end

function UILoading:loadUI()
    for i = 1, #self.preLoadList do
        if self.preLoadList[i].assetType == _EPreLoadResType.UI then
            uiMgr:openUI(self.preLoadList[i].assetName)
        elseif self.preLoadList[i].assetType == _EPreLoadResType.Map then
            self:loadCompleted()
            local obj = resMgr:loadObject("map_"..self.preLoadList[i].assetName, self.preLoadList[i].assetName)
            if(self.preLoadList[i].callBack ~= nil) then
                self.preLoadList[i].callBack(obj)
            end
        elseif self.preLoadList[i].assetType == _EPreLoadResType.Unit then
            self:loadCompleted()
            local obj = resMgr:loadObject("unit_"..self.preLoadList[i].assetName, self.preLoadList[i].assetName)
            if self.preLoadList[i].callBack ~= nil then
                if self.preLoadList[i].callBackTable ~= nil then
                    self.preLoadList[i].callBack(self.preLoadList[i].callBackTable, self.preLoadList[i].callBackArgs, obj)
                else
                    self.preLoadList[i].callBack(obj)
                end
            end
        elseif self.preLoadList[i].assetType == _EPreLoadResType.Effect then
            self:loadCompleted()
            local obj = resMgr:loadObject("eff_"..self.preLoadList[i].assetName, self.preLoadList[i].assetName)
            if self.preLoadList[i].callBack ~= nil then
                if self.preLoadList[i].callBackTable ~= nil then
                    self.preLoadList[i].callBack(self.preLoadList[i].callBackTable, self.preLoadList[i].callBackArgs, obj)
                else
                    self.preLoadList[i].callBack(obj)
                end
            end
        elseif self.preLoadList[i].assetType == _EPreLoadResType.TextData then
            self:loadCompleted()
            local obj = resMgr:loadObject("data_"..self.preLoadList[i].assetName, self.preLoadList[i].assetName)
            if(self.preLoadList[i].callBack ~= nil) then
                self.preLoadList[i].callBack(self.preLoadList[i].callBackTable, self.preLoadList[i].callBackArgs, obj)
            end
        end
    end
end

function UILoading:onUpdate()
    if self.progressBar.value < self.curProgress then
        self.progressBar.value = self.progressBar.value + Time.deltaTime * 6
        local barVal = math.floor(self.progressBar.value * (100 / #self.preLoadList))
        if barVal >= 100 then
            barVal = 100
        end
        if self.loadType == 0 then
            self.title.text = dataConfigMgr.getLanguage(1062).."("..barVal.."%)"
        else
            self.title.text = dataConfigMgr.getLanguage(1066).."("..barVal.."%)"
        end
    elseif self.progressBar.value >= self.progressBar.maxValue then
        levelMgr:loadCompleted()
        uiMgr:closeUI(_UI.Loading)
    end
end

function UILoading:loadCompleted()
    self.curProgress = self.curProgress + 1
end

function UILoading:onClear()
    _gameTools.removeUpdate(self.updateHandler)
end

--随机取一条提示
function UILoading:randomGetTips()
    if self.isOpenRandomTips then
        self.randomTime = self.randomTime + Time.deltaTime
        if self.randomTime >= 2 then
            self.tips.text = dataConfigMgr.getLanguage( math.floor( math.random() * 41) + 1)
            self.randomTime = 0
        end
    end
end

return UILoading
--endregion
