--region 加载界面
--Date
--此文件由[BabeLua]插件自动生成
require "ui/uiBase"

UIShop = Class(UIBase)



function UIShop:start()
	self:addClickByPath("content/closeBtn", self.onCloseBtn) 
    self.goldNum = self:getCom("content/gold/num",_UICom.Text)
    self.perGoldNum = self:getCom("content/gold/per",_UICom.Text)
    self.diamondNum = self:getCom("content/diamond/num",_UICom.Text)
    self.shopGunList = self:getCom("content/list", _UICom.UIList)
    self.vigorNum = self:getCom("content/vigor/num",_UICom.Text)
    self.content = self:getObj("content")

    self.shopGunObj = self:getObj("content/list")
    self.shopGunList:setProxy(self, "onItemShow", self.onItemShow)
  
    self.playerData = gameDataManager.playerData
    self.gunCfg = dataConfigMgr.getFirearmsTab()
    
    self.currentPos = 0
    self.cdTime = 0
    self.isStart = false
    self.gunMes = {}
    self.shopItemList = {}
    self:refreshGoldAndDiamond()
    self:bindPanelData()

    _gameTools.popupShowAnim(self.content)
    self:registerEvent(_EventType.RefreshProductPerSec, self, self.refreshGoldAndDiamond)
    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self) 
end

function UIShop:onCloseBtn()
    self:closeSelf()
end

function UIShop:onClear()
    _gameTools.removeUpdate(self.updateHandler)
end

function UIShop:onUpdate()
    self:showVigorTime()
end

function UIShop:showVigorTime()
    if self.isStart then
        self.cdTime = self.cdTime + Time.deltaTime
        if self.cdTime >= 1 then            
            if uiMgr:getUI(_UI.Main).mainTime == nil then
                self.vigorNum.text = gameDataManager.getVigor().."/10"
                self.isStart = false
            else
                self.vigorNum.text = uiMgr:getUI(_UI.Main).mainTime
            end
            self.cdTime = 0
        end
    end
end

function UIShop:refreshGoldAndDiamond()
    self.goldNum.text = _gameTools.convertNumberToLabelString(gameDataManager.playerData.money)
    self.diamondNum.text = _gameTools.convertNumberToLabelString(gameDataManager.getDiamond())
    local num = gameDataManager.getProductPerSec()
    self.perGoldNum.text = _gameTools.convertNumberToLabelString(num) .."/"..dataConfigMgr.getLanguage(1012)
    self.vigorNum.text = gameDataManager.getVigor()
end

function UIShop:bindPanelData()
    local gunLv = self.playerData.maxGunLv   
    if gameDataManager.getVigor() <= 0 then
        self.isStart = true
        self.vigorNum.text = uiMgr:getUI(_UI.Main).mainTime
    else
        self.vigorNum.text = gameDataManager.getVigor().."/10"
    end
              
    self.shopGunList:clear()
    for i = 1,#self.gunCfg do
        local data = {}
        data["icon"] = dataConfigMgr.getFirearms(i).icon

        if i <= gunLv then    
            if gunLv - 4 > 0 then                
                if i <= gunLv - 4 then
                    data["index"] = i
                    data["state"] = 1
                    if i == gunLv - 5 then --视频购买 
                        data["index"] = i
                        data["state"] = 3
                    end
                else
                    data["index"] = i
                    data["state"] = 4
                end
            else
                if i == 1 then
                    data["index"] = i
                    data["state"] = 1
                else
                    data["index"] = i
                    data["state"] = 4
                end
            end
            if gunLv >= _globalCfg.diamondBuyLv then
                if (i == gunLv - 2) or (i == gunLv - 3) then
                    data["index"] = i
                    data["state"] = 2
                end
            end
        else -- 未解锁
            data["index"] = i
            data["state"] = 0 
        end
        local item = self.shopGunList:addItem(data)
        self.shopItemList[i] = item    
    end
    self.shopGunList:refresh()
end

--每一个枪的售卖信息
function UIShop:onItemShow(item,data)
    local rank = self:getCom("gunRankBg/gunRank",_UICom.Text, item.go)
    local gunIcon = self:getCom("gunIcon",_UICom.Image,item.go)
    local gunName = self:getCom("gunIcon/gunName",_UICom.Text,item.go)
    local goldPrice = self:getCom("buyBtn/price",_UICom.Text,item.go)
    local diamondPrice = self:getCom("diamondBtn/price",_UICom.Text,item.go)
    local lockPrice = self:getCom("lockBtn/price",_UICom.Text,item.go)
    local freePrice = self:getCom("freeBtn/price",_UICom.Text,item.go)
    local buyBtn = self:getObj("buyBtn",item.go)
    local diamondBtn = self:getObj("diamondBtn",item.go)
    local freeBtn = self:getObj("freeBtn",item.go)
    local lockBtn = self:getObj("lockBtn",item.go)
    local state = data.state

    self:addClickByPath("buyBtn", self.onBuyBtn,item.go) 
    self:addClickByPath("diamondBtn", self.onDiamondBtn,item.go) 
    self:addClickByPath("freeBtn", self.onVideoBtn,item.go) 
    self:addClickByPath("diamondBtn", self.onBuyBtn,item.go) 
    self:addClickByPath("freeBtn", self.onBuyBtn,item.go) 
    rank.text = dataConfigMgr.getFirearms(data.index).id
    gunName.text = dataConfigMgr.getFirearms(data.index).name
    gunIcon.sprite = self:loadObject("atlas_gunIcon", data.icon)
    buyBtn:SetActive(false)
    freeBtn:SetActive(false)
    diamondBtn:SetActive(false)
    lockBtn:SetActive(false)
    if state == 0 then
        lockPrice.text = dataConfigMgr.getLanguage(1014)
        gunIcon.color = Color(0,0,0,1)
        lockBtn:SetActive(true)
    elseif state == 1 then
        goldPrice.text = _gameTools.convertNumberToLabelString(gameDataManager.calExpendGoldNum(data.index))
        buyBtn:SetActive(true)
    elseif state == 2 then
        diamondPrice.text = _gameTools.convertNumberToLabelString(gameDataManager.calExpendDiamondNum(data.index))
        diamondBtn:SetActive(true)
    elseif state == 3 then
        freePrice.text = dataConfigMgr.getLanguage(1013)
        if not sdkMgr:getVideoPointIsUseUp(25) then
            freeBtn:SetActive(true)
        else
            goldPrice.text = _gameTools.convertNumberToLabelString(gameDataManager.calExpendGoldNum(data.index))
            buyBtn:SetActive(true)
        end
    elseif state == 4 then
        lockPrice.text = dataConfigMgr.getLanguage(1015)
        lockBtn:SetActive(true)
    end
end

--点击购买枪的按钮
function  UIShop:onBuyBtn(event)
    local val = gameDataManager.bagIsFull()
    if val then
        local str = tostring(event.transform.parent.name)
        local index = string.sub(str,5) + 1 
        local price = gameDataManager.calExpendGoldNum(index)
        if gameDataManager.useGold(price) then
            gameDataManager.addExpendGoldTimes(index)
            uiMgr:getUI(_UI.Main):addFirearmsToGrid(val, index)
            eventMgr:broadcastEvent(_EventType.RefreshProductPerSec)
            uiMgr:getUI(_UI.Main):addFirearmsToBag(index, true)
            self:bindPanelData()
        else
            --金币不足弹窗
            uiMgr:openUI(_UI.FreeGet,false,{name = "gold"})
        end    
    else
        uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1044))
    end
end

--点击钻石购买按钮
function UIShop:onDiamondBtn(event)
    local val = gameDataManager.bagIsFull()
    if val then
        local str = tostring(event.transform.parent.name)
        local index = string.sub(str,5) + 1
        local diamond = gameDataManager.calExpendDiamondNum(index)
        if gameDataManager.useDiamond(diamond) then
            gameDataManager.addExpendDiamondTimes(index)
            uiMgr:getUI(_UI.Main):addFirearmsToGrid(val, index)
            eventMgr:broadcastEvent(_EventType.RefreshProductPerSec)
            self:bindPanelData()
        else
            --钻石不足
            uiMgr:openUI(_UI.FreeGet,false,{name = "diamond"})
        end
    else
        uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1044))
    end
end

--点击视频按钮够买
function UIShop:onVideoBtn(event)
    local val = gameDataManager.bagIsFull()
    if val then
        local opts = {}
        opts.unitId = 25
        opts.objectTable = self
        opts.callBack = self.onVideoCallBack
        sdkMgr:showAd(opts)

        local str = tostring(event.transform.parent.name)
        local index = string.sub(str,5) + 1
        uiMgr:getUI(_UI.Main):addFirearmsToGrid(val, index)
        self:bindPanelData()
    else
        uiMgr:getUI(_UI.FloatTips):shwoGetAwardTipsAnim(dataConfigMgr.getLanguage(1044))
    end
end

function UIShop:onVideoCallBack()
    
end

return UIShop
--endregion