--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

require "common/class"

Enemy = Class()

function Enemy:ctor()
    
    self.animaWeight = 
    {
        ["death1"] = 0,
        ["death2"] = 0,
        ["jumpF"] = 1,
        ["jumpR"] = 1,
        ["shoot6"] = 1,
        ["squat"] = 2,
        ["squatMove"] = 2,
        ["shoot1"] = 3, 
        ["shoot2"] = 3,
        ["shoot3"] = 3,
        ["shoot4"] = 3,
        ["shoot5"] = 3,
        ["moveL"] = 4,
        ["moveR"] = 4,
        ["moveF"] = 4,
        ["beHit"] = 4,
        ["idle"] = 4,
    }
end

function Enemy:init(enemyId, unitObj, shootCountdown, firearmsAttrIndex, operateStr)
    self.enemyId = enemyId
    self.unitObj = unitObj
    self.unitObj.name = "enemyBody" .. self.enemyId
    self.trans = self.unitObj.transform
    local bodyTrans = self.trans:Find("enemyBody")
    bodyTrans.name = bodyTrans.name .. self.enemyId
    self.animator = bodyTrans:GetComponent("Animator")
    local headTrans = bodyTrans:Find("Bip001/Bip001 Pelvis/Bip001 Spine/Bip001 Spine1/Bip001 Spine2/Bip001 Neck/enemyHead")
    headTrans.name = headTrans.name .. self.enemyId
    self.headCollider = headTrans:GetComponent("SphereCollider")

    self.animator2 = self.trans:Find("Qiang"..firearmsAttrIndex):GetComponent("Animator")
    self.animator2.gameObject:SetActive(true)
    if firearmsAttrIndex == 1 then
        self.muzzlePos = self.animator2.transform:Find("QiangE_bone/muzzlePos")
    elseif firearmsAttrIndex == 2 then
         self.muzzlePos = self.animator2.transform:Find("QiangA_bone/muzzlePos")
    elseif firearmsAttrIndex == 3 then
         self.muzzlePos = self.animator2.transform:Find("QiangB_bone/muzzlePos")
    elseif firearmsAttrIndex == 4 then
         self.muzzlePos = self.animator2.transform:Find("QiangC_bone/muzzlePos")
    elseif firearmsAttrIndex == 5 then
         self.muzzlePos = self.animator2.transform:Find("QiangD_bone/muzzlePos")
    end
    
    self.muzzleFlashObj = battleMgr:getModelObject("muzzleFlash3")
    self.muzzleFlashObj.transform:SetParent(self.muzzlePos.transform)
    self.muzzleFlashObj.transform.localPosition = Vector3(0,0,1.154)
    self.muzzleFlashObj.transform.localEulerAngles = Vector3(-180,0,0)
    self.muzzleFlashObj.transform.localScale = Vector3(1,1,1)
    self.muzzleFlashObj:SetActive(false)
    self.characterCtrl = self.unitObj:GetComponent("CharacterController")
    self.canvasRoot = self.trans:Find("uiCanvas")
    self.hpBarRoot = self.trans:Find("uiCanvas/bloodBar")
    self.hpBar = self.trans:Find("uiCanvas/bloodBar/bar"):GetComponent(_UICom.Image)
    self.hpBarRed = self.trans:Find("uiCanvas/bloodBar/barRed"):GetComponent(_UICom.Image)
    self.hpBar.fillAmount = 1
    self.hpBarTimer = 0
    self.hpBarRoot.gameObject:SetActive(false)
    self.snipeBarRoot = self.trans:Find("uiCanvas/snipeBar")
    self.snipeBar = self.trans:Find("uiCanvas/snipeBar/bar"):GetComponent(_UICom.Image)
    self.snipeBarRoot.gameObject:SetActive(false)

    self.shootCountdown = shootCountdown
    self.firearmsType = firearmsAttrIndex
    self.grivaty = 20
    self.speed = 4
    self.frameCount = 10
    self.frameTimer = 0
    self.curHP = battleMgr.curLevelCfg.enemyHP
    self.isDie = false
    self.characterCtrl.enabled = true
    self.shootInterval = battleMgr.enemyFirearmsAttr[firearmsAttrIndex].shootInterval
    self.shootNumPerFire = battleMgr.enemyFirearmsAttr[firearmsAttrIndex].shootPerFire
    self.shootCount = 0
    self.shootTime = 0
    self.isReloadClip = false
    self.fireTime = 0
    self.fireInterval = battleMgr.enemyFirearmsAttr[firearmsAttrIndex].fireInterval
    self.stability = battleMgr.enemyFirearmsAttr[firearmsAttrIndex].stability
    self.atk = battleMgr.curLevelCfg.enemyAtk[firearmsAttrIndex]
    self.moveDir = nil
    self.moveState = 0
    self.avoidProb = battleMgr.curLevelCfg.avoidProb

    self.isPlayOperate = false
    self.isCanShoot = false
    self.isRaiseShoot = false
    self.isDieFall = false

    self.lastOperateData = nil
    self.isExistAvoidPos = false
    self.avoidPos = nil
    self:decodeOperate(operateStr)
    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self)

    if self.firearmsType == 5 then
        self.snipeBarRoot.gameObject:SetActive(true)
    else
        self.snipeBarRoot.gameObject:SetActive(false)
    end

    self.inited = true
    self.beHitNum = 0

    self.trans.position = self.operateList[1].pos
end

function Enemy:decodeOperate(operateStr)
    local ret = {}
    local strArr1 = splitToString(operateStr, "|")
    for i = 1,#strArr1 - 1 do
        local info = {}
        local strArr2 = splitToString(strArr1[i], ";")
        if string.find(strArr2[1], ",") ~= nil then
            local numArr = splitToNumber(strArr2[1], ",")
            info.pos = Vector3.New(numArr[1] / 10.0, numArr[2] / 10.0, numArr[3] / 10.0)
        end

        if string.find(strArr2[2], ",") ~= nil then
            local numArr = splitToNumber(strArr2[2], ",")
            info.forward = Vector3.New(numArr[1] / 10.0, numArr[2] / 10.0, numArr[3] / 10.0)
        end

        info.isJump = strArr2[3] == "1"
        info.isSquat = strArr2[4] == "1"
        table.insert(ret, info)
    end
    local strArr3 = splitToString(strArr1[#strArr1], ";")
    if string.find(strArr3[2], ",") then
        self.isExistAvoidPos = true
        local numArr = splitToNumber(strArr3[2], ",")
        self.avoidPos = Vector3.New(numArr[1] / 10.0, numArr[2] / 10.0, numArr[3] / 10.0)
    else
        self.isExistAvoidPos = false
        self.avoidPos = nil
    end
    self.operateList = ret
end

function Enemy:onUpdate()
    self:deathFall()

    if battleMgr.fightState == 0 then
        return
    end

    if not self.inited then
        return
    end

    if self.hpBarTimer > 0 then
        self.hpBarTimer = self.hpBarTimer - Time.deltaTime
        if self.hpBarTimer <= 0 then
            self.hpBarRoot.gameObject:SetActive(false)
        end
    end
    if self.hpBarRoot.gameObject.activeSelf then
        self.hpBarRoot:LookAt(battleMgr.player.cameraObj.transform)
    end

    if self.isDie then
        return
    end

    battleMgr:checkEnemyInPlayerView(self)

    if not self.isPlayOperate then
        self:playOperate()
    end

    if not self.isCanShoot then
        self.shootCountdown = self.shootCountdown - Time.deltaTime
        if self.shootCountdown <= 0 then
            self.isCanShoot = true
        end
    end

    if self.isCanShoot and battleMgr.enemyCanShoot then
        local dir = battleMgr.player.trans.position - self.trans.position
        local forward = dir.normalized
        local isNeedRaise = forward.y > 0
        forward.y = 0
        self.trans.forward = forward
        local angle = Vector3.Angle(dir.normalized, forward)
        if angle >= 20 and isNeedRaise then
            self.isRaiseShoot = true
            self:playAnima("shoot6", 1)
        end

        if self.fireTime + self.fireInterval > Time.time then
            if self.snipeBarRoot.gameObject.activeSelf then
                self.snipeBarRoot:LookAt(battleMgr.player.cameraObj.transform)
                self.snipeBar.fillAmount = (Time.time - self.fireTime) / self.fireInterval
            end
        else
            self:fire()
        end
    end

    if self.moveState == 3 then
        self.idleTimer = self.idleTimer - Time.deltaTime
        if self.idleTimer <= 0 then
            self:randomBehaviour()
        end
    elseif self.moveState == 1 then
        local v3 = self.avoidPos - self.trans.position
        self.moveDir = Vector3.New(v3.x, 0, v3.z).normalized
        self.moveDir = self.moveDir * self.speed
        self.moveDir.y = self.moveDir.y - self.grivaty * Time.deltaTime
        if v3.magnitude <= 0.1 then
            self:playAnima("idle")
            self.moveState = 2
        else
            local angle = Vector3.Angle(self.trans.forward, self.moveDir.normalized)
            if angle > 30 then
                self.moveDir = self.moveDir * 0.5

                if Vector3.Cross(self.trans.forward, self.moveDir).y > 0 then
                    self:playAnima("moveR")
                else
                    self:playAnima("moveL")
                end
                
            else
                self:playAnima("moveF")
            end
            self.characterCtrl:Move(self.moveDir * Time.deltaTime)
        end
        
    elseif self.moveState == 2 then
        local v3 = self.lastOperateData.pos - self.trans.position
        self.moveDir = Vector3.New(v3.x, 0, v3.z).normalized
        self.moveDir = self.moveDir * self.speed
        self.moveDir.y = self.moveDir.y - self.grivaty * Time.deltaTime
        if v3.magnitude <= 0.1 then
            self:playAnima("idle")
            self:randomBehaviour()
        else
            local angle = Vector3.Angle(self.trans.forward, self.moveDir.normalized)
            if angle > 30 then
                self.moveDir = self.moveDir * 0.5
                if Vector3.Cross(self.trans.forward, self.moveDir).y > 0 then
                    self:playAnima("moveR")
                else
                    self:playAnima("moveL")
                end
            else
                self:playAnima("moveF")
            end
            self.characterCtrl:Move(self.moveDir * Time.deltaTime)
        end
    end
end

function Enemy:randomBehaviour()
    if not self.isExistAvoidPos then
        return
    end

    local avoidRandom = math.random()
    if avoidRandom <= self.avoidProb then
        self.moveState = 1
    else
        self.animator:Play("idle")
        self.animator2:Play("idle")
        self.moveState = 3
        self.idleTimer = math.random(3, 6)
    end
end

function Enemy:fire()
    if self.shootTime + self.shootInterval > Time.time then
        return
    end

    self.shootTime = Time.time
    self.shootCount = self.shootCount + 1
    
    if self.shootCount >= self.shootNumPerFire then
        self.shootCount = 0
        self.fireTime = Time.time
    end

    local bulletDir = ((battleMgr.player.cameraObj.position + Vector3.New(math.random() * 0.5 - 0.25, math.random() * 0.5 - 0.25, math.random() * 0.5 - 0.25)) - self.muzzlePos.position).normalized
    local bulletFire = battleMgr:getFreeBulletFire()
    bulletFire:init(self.muzzlePos.position, bulletDir)

    local hitRandom = math.random()
    if hitRandom <= self.stability then
        battleMgr:showBeHitDirImg(self)
        battleMgr.player:beHit(self.atk)
    end

    if self.muzzleFlashObj ~= nil then
        self.muzzleFlashObj:SetActive(false)
        self.muzzleFlashObj:SetActive(true)
    end

    audioMgr:playSound("shoot_enemy")
    if not self.isRaiseShoot then
        self:playAnima("shoot"..self.firearmsType, 1)
    end
end

function Enemy:playOperate()
    if #self.operateList > 0 then
        if self.frameTimer % self.frameCount == 0 then
            self.frameTimer = 0
            local info = table.remove(self.operateList, 1)
            self.lastOperateData = info
            self.trans.position = info.pos
            self.trans.forward = info.forward

            if info.isJump then
                self:playAnima("jumpF")
            else
                local animatorInfo = self.animator:GetCurrentAnimatorStateInfo(0)
                if animatorInfo.normalizedTime <= 1.0 and animatorInfo:IsName("jumpF") then
                    
                else
                    if #self.operateList > 0 then
                        if self.operateList[1].pos == info.pos then
                            if info.isSquat then
                                self:playAnima("squat")
                            else
                                self:playAnima("idle")
                            end
                        else
                            if info.isSquat then
                                self:playAnima("squatMove")
                            else
                                local moveDir = self.operateList[1].pos - info.pos
                                local angle = Vector3.Angle(info.forward, moveDir.normalized)
                                if angle > 30 then
                                    self:playAnima("moveR")
                                else
                                    self:playAnima("moveF")
                                end
                            end
                        end
                    else
                        if info.isSquat then
                            self:playAnima("squat")
                        else
                            self:playAnima("idle")
                        end
                    end
                end
            end
        else
            local info = self.operateList[1]
            self.trans.position = self.lastOperateData.pos + (info.pos - self.lastOperateData.pos) * self.frameTimer / self.frameCount
            self.trans.forward = self.lastOperateData.forward + (info.forward - self.lastOperateData.forward) * self.frameTimer / self.frameCount
        end
        self.frameTimer = self.frameTimer + 1
    else
        self.isPlayOperate = true
        self:randomBehaviour()
    end
end

function Enemy:playAnima(animaName, layer)
--    if animaName == "beHit" then
--        self.beHitNum = self.beHitNum + 1
--        animaName = "jumpF"--animaName .. (self.beHitNum % 2)
--        _gameTools.luaError(animaName)
--    end

    if layer == nil then
        self.animator:Play(animaName, 0)

        local aClips = self.animator:GetCurrentAnimatorClipInfo(1)
        local animatorInfo1 = self.animator:GetCurrentAnimatorStateInfo(1)
        if aClips.Length == 0 then
            self.animator:Play(animaName, 1)
            self.animator2:Play(animaName, 0)
        else
            if self.animaWeight[animaName] <= self.animaWeight[aClips[0].clip.name] then
                self.animator:Play(animaName, 1)
                self.animator2:Play(animaName, 0)
    --        else
    --            if aClips[0].clip.name ~= "shoot6" and animatorInfo1.normalizedTime >= 1 then
    --                self.animator:Play(animaName, 1)
    --                self.animator2:Play(animaName, 0)
    --            end
            end
        end
        
    else
        if layer == 1 then
            local aClips = self.animator:GetCurrentAnimatorClipInfo(layer)
            local animatorInfo1 = self.animator:GetCurrentAnimatorStateInfo(layer)
            if aClips.Length <= 0 then
                _gameTools.luaError("aClips.Length == 0")
            end
            if aClips.Length <= 0 or self.animaWeight[animaName] <= self.animaWeight[aClips[0].clip.name] then
                self.animator:Play(animaName, layer)
                self.animator2:Play(animaName, 0)
                
--            else
--                if animatorInfo1.normalizedTime >= 1 then
--                    self.animator:Play(animaName, layer)
--                    self.animator2:Play(animaName, 0)
--                end
            end
        else
            self.animator:Play(animaName, layer)
            self.animator2:Play(animaName, 0)
        end
    end
end

function Enemy:beHit(atk, isShootOnHead)
    self.curHP = self.curHP - atk
    self:updateHpBar(atk > self.curHP and self.curHP or atk)
    battleMgr.enemyCanShoot = true

    if self.curHP <= 0 then
        self.curHP = 0
        self.hpBarTimer = 1
        self:death(isShootOnHead)
    else
        self:playAnima("beHit", 1)
    end
end

function Enemy:updateHpBar(atk)
    self.hpBarTimer = 2
    self.hpBarRoot.gameObject:SetActive(true)
    local num = self.curHP / battleMgr.curLevelCfg.enemyHP

    local barRedInst = GameObject.Instantiate(self.hpBarRed.gameObject)
    barRedInst.transform:SetParent(self.hpBarRoot)
    barRedInst.transform.localEulerAngles = Vector3.zero
    local barRedRectTrans = barRedInst:GetComponent(_UICom.RectTransform)

    local width = atk / battleMgr.curLevelCfg.enemyHP * 1.5
    barRedRectTrans.sizeDelta = Vector2(width, 0.1)
    barRedRectTrans.localPosition = Vector3(0.75 - num * 1.5 - width / 2, 0, 0)
    
    _DoTweenHelper:TweenColor(barRedRectTrans.gameObject, Color.New(1,1,1,1), 0.35, function()
        _DoTweenHelper:ScaleXYZ(barRedRectTrans.gameObject, Vector3.New(1.7,7,1), Ease.Linear, 0.15, 0, nil)
        _DoTweenHelper:Fade(barRedRectTrans.gameObject, 0, 0.15, function()
            GameObject.Destroy(barRedRectTrans.gameObject)
        end)
    end)

    self.hpBar.fillAmount = num
end

function Enemy:deathFall()
    if self.isDieFall then
        if self.trans.position.y > self.landY then
            self.trans.position = self.trans.position - Vector3(0, 2, 0) * Time.deltaTime
        else
            self.isDieFall = false
        end
    end
end

function Enemy:death(isShootOnHead)
    if self.isDie then
        return
    end

    if isShootOnHead then
        battleMgr:getUIBattle():showShootOnHead()
    else
        battleMgr:getUIBattle():showKillIcon()
    end

    battleMgr:getUIBattle():showKillTips(isShootOnHead)

    self.isDie = true
    self.isDieFall = true
--    _gameTools.luaError(self.trans.parent.name .. "Edearsdfsdlfkj")
    local ray = Ray.New(Vector3.New(0, -1, 0), self.trans.position + Vector3(0,0.1,0))
    local isHit, hitInfo = Physics.Raycast(ray, RaycastHit.out)
    if isHit then
        if self.trans.position.y > hitInfo.point.y then
            self.landY = hitInfo.point.y
        else
            self.landY = self.trans.position.y
        end
    else
        self.landY = self.trans.position.y
    end

    self.snipeBarRoot.gameObject:SetActive(false)
    self.characterCtrl.enabled = false
    self.headCollider.enabled = false
    audioMgr:playSound("enemy_death"..math.random(1,4))
    self:playAnima("death"..math.random(1,2))
    battleMgr:getUIBattle():hideEnemyDirTips(self)
    battleMgr:enemyDie(self.enemyId, isShootOnHead)
    coroutine.start(function()
        coroutine.wait(3)
        if self.unitObj ~= nil then
            self.unitObj:SetActive(false)
        end
    end)
end

function Enemy:clear()
    self.inited = false
    self.unitObj = nil
    _gameTools.removeUpdate(self.updateHandler)
end

--endregion
