--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require "common/class"

Player = Class()

function Player:ctor()
--    unitObj.transform.position = Vector3.New(48,14,41)
end

function Player:init(unitObj, operateStr)
    self.unitObj = unitObj
    self.trans = self.unitObj.transform
    self.characterCtrl = self.unitObj:GetComponent("CharacterController")
    self.moveDirection = Vector3.zero
    self.gravity = 20.0
    self.curSpeed = 4.0
    self.speed = 4.0
    self.jumpSpeed = 8.0
    self.squatSpeed = 3.0
    self.rotationY = 0.0
    self.rotationMid = 0
    self.rotationSpeed = 10
    self.maxHP = 100
    self.curHP = self.maxHP
    self.isDie = false
    self.walkAudioTimer = 0

    self.isTouched = false
    self.shootDuration = 0
    self.isCanFire = false
    self.touchStartPos = nil
    self.firearmsForceSpeed = 10
    self.firearmsForce = 0
    self.firearmsForceY = 0
    self.firearmsDecline = 45
    self.firearmsForceOffsetX = 0
    self.isChangeCameraRotateX = false
    self.isChangeRotateY = false
    self.firearmsForceOffsetY = 0
    self.firearmsShakeYDir = 1
    self.autoRotateSpeed = 30

    --新手引导关卡滑动状态
    self.guideLevelScrollState = 0

    self.armRoot = self.trans:Find("Camera/armRoot")
    self.armState = 1
    self.armStateTimer1 = 0
    self.armStateTimer2 = 0

    --camera
    self.cameraObj = self.trans:Find("Camera")
    self.cameraCom = self.cameraObj:GetComponent("Camera")
    self.deathRotateX = 90
    self.maxRotateX = 60
    self.minRotateX = -60
    self.cameraRotateSpeed = 15
    self.cameraRotateX = 0

    local useGunId = gameDataManager.getUseGunLv()
    if battleMgr.levelId == 1 then
        useGunId = 1000
    end
    self.gunCfg = dataConfigMgr.getFirearms(useGunId)
    local gunObj = battleMgr:getModelObject(self.gunCfg.model)
    gunObj.transform:SetParent(self.armRoot)
    if self.weapon == nil then
        self.weapon = Weapon.new()
    end
    self.weapon:init(useGunId, gunObj)
    
    self.isViewZoomIn = false
    self.isViewZoomOut = false

    self.frameCount = 10
    self.frameTimer = 0
    self.isSquating = false
    self.isPlayOperateFinish = true
    self.lastOperateData = nil
    self.operateMap = self:decodeOperate(operateStr)
    self.operateList = {}

    self.updateHandler = _gameTools.addUpdate(self.onUpdate, self)

    self.inited = true

    if battleMgr.levelId == 1 then
        self.cameraObj.localEulerAngles = Vector3(5, 0,0)
    end

    battleMgr:getUIBattle():refreshHP(self.curHP, self.maxHP)

    self.armRoot.localEulerAngles = Vector3(0,0,0)
end

function Player:decodeOperate(operateStr)
    local ret = {}
    local strArr1 = splitToString(operateStr, "|")
    for i = 1,#strArr1 - 1 do
        local tempList = {}
        local strArr2 = splitToString(strArr1[i], ";")
        for j = 1, #strArr2 do
            local info = {}
            local numArr = splitToNumber(strArr2[j], ",")
            info.pos = Vector3.New(numArr[1] / 10.0, numArr[2] / 10.0, numArr[3] / 10.0)
            info.isJump = numArr[4] == 1
            info.isSquat = numArr[5] == 1
            if j == #strArr2 and numArr[7] ~= nil then
                info.rotateY = numArr[7]
            end
            table.insert(tempList, info)
        end
        ret[i] = tempList
    end
    return ret
end

function Player:startPlayOperate(wave)
    self.curWave = wave
    self.isPlayOperateFinish = false
    self.operateList = self.operateMap[self.curWave]
    self.rotationMid = self.operateList[#self.operateList].rotateY
    self.trans.position = self.operateList[1].pos
    self.deltaAngle = 60
    if battleMgr.levelId == 1 then
        if wave == 1 then
            self.trans.localEulerAngles = Vector3(0, self.rotationMid, 0)
        end
        local pEnemy = battleMgr:getAliveEnemy()
        local dir1 = pEnemy.trans.position - self.trans.position
        local dir2 = self.trans.forward
        self.trans.forward = dir1
        local angleY = self.trans.localEulerAngles.y
        self.trans.forward = dir2
        self.deltaAngle = Vector3.Angle(dir1, dir2)
        self.rotationMid = self.trans.localEulerAngles.y
    end
    self.armState = 2
    self.rotateTimer = 0
    self.startLocalRotation = self.trans.localRotation
    if self.weapon.bulletNum / self.weapon.gunCfg.clipSize <= _globalCfg.autoReloadClipPercent then
        self.weapon:manualReloadClip()
    end
    if self.rotationMid == nil then
        self.autoRotate = false
    else
        self.autoRotate = true
    end
end

function Player:onUpdate()
    if battleMgr.fightState == 0 then
        return
    end

    if not self.inited then
        return
    end

    if self.isDie then
        self:deathView()
        return
    end

    self:operateTouch()
    self:operateCamera()
    if not self.autoRotate then
        self:operateRotate()
    end
    if not self.isPlayOperateFinish then
        self:playOperate()
    end
    self:operateSquat()
    self:checkFire()
    self.weapon:onUpdate()
    self:updateFieldOfView()
    self:doArmAnimation()
end

function Player:doArmAnimation()
    if self.armState == 1 then
        self.armStateTimer1 = self.armStateTimer1 + Time.deltaTime
        local pos = self.armRoot.localPosition
        self.armRoot.localPosition = Vector3(pos.x, math.sin(self.armStateTimer1 * 2) * 0.01, pos.z)
    elseif self.armState == 2 then
        self.armStateTimer2 = self.armStateTimer2 + Time.deltaTime
        local yParam = math.abs(math.sin(self.armStateTimer2 * 8))
        self.armRoot.localPosition = Vector3(math.cos(self.armStateTimer2 * 8) * 0.04, yParam * 0.02,0)
    end
end

function Player:operateTouch()
    if Input.GetMouseButtonDown(0) and battleMgr:isTouchOnTouchObj() then
        self.isTouched = true
--        self.autoRotate = false
        self.touchStartY = Input.mousePosition.y
        self.touchStartX = Input.mousePosition.x
        battleMgr:getUIBattle():touchStart()
        self:checkIsSniper(true)
    elseif Input.GetMouseButtonUp(0) and self.isTouched then
        self.isTouched = false
        self.shootDuration = 0
        battleMgr:getUIBattle():touchEnd()
        self:checkIsSniper(false)
    end
end

function Player:operateCamera()
    if self.guideLevelScrollState ~= 0 then
        return
    end
    if self.isTouched and math.abs(Input.mousePosition.y - self.touchStartY) >= 1 then
        if self.gunCfg.type == 5 then
            self.cameraRotateX = self.cameraRotateX - (Input.mousePosition.y - self.touchStartY) * self.rotationSpeed * gameDataManager.playerData.touchMoveSensitivity  / 30 * Time.deltaTime
        else
            self.cameraRotateX = self.cameraRotateX - (Input.mousePosition.y - self.touchStartY) * self.rotationSpeed * gameDataManager.playerData.touchMoveSensitivity  / 10 * Time.deltaTime
        end
        
        self.cameraRotateX = _gameTools.mathClamp(self.cameraRotateX, self.minRotateX, self.maxRotateX)
        self.touchStartY = Input.mousePosition.y
    end
    self.firearmsForceOffsetX = self.firearmsForceOffsetX + self.firearmsForce * self.firearmsForceSpeed * Time.deltaTime
    if self.firearmsForceOffsetX <= 0 then
        self.firearmsForceOffsetX = 0
    end

    self.firearmsForceOffsetY = self.firearmsForceOffsetY + (self.firearmsShakeYDir * self.firearmsForceY * self.firearmsForceSpeed * 0.2 - self.firearmsForceOffsetY * 50) * Time.deltaTime

    self.cameraObj.localEulerAngles = Vector3.New(self.cameraRotateX - self.firearmsForceOffsetX,
       self.firearmsForceOffsetY, 0)

    if self.isChangeCameraRotateX then
        self.cameraRotateX = self.cameraRotateX - self.firearmsForceOffsetX
        self.isChangeCameraRotateX = false
        self.firearmsForceOffsetX = 0
    end

    if self.firearmsForceY > 0 then
        self.firearmsForceY = self.firearmsForceY - Time.deltaTime
        if self.firearmsForceY <= 0 then
            self.firearmsForceY = 0
        end
    end
    self.firearmsForce = self.firearmsForce - self.firearmsDecline * Time.deltaTime
end

function Player:operateSquat()
    if self.isSquating then
        self.cameraObj.localPosition = Vector3.MoveTowards(self.cameraObj.localPosition, Vector3.New(0,0.84,0), Time.deltaTime * self.squatSpeed)
    else
        self.cameraObj.localPosition = Vector3.MoveTowards(self.cameraObj.localPosition, Vector3.New(0,1.8,0), Time.deltaTime * self.squatSpeed)
    end
end

function Player:inputControl(x, z)
    self.moveDirection = Vector3.New(x, 0, z)
    self.moveDirection = self.trans:TransformDirection(self.moveDirection)
    self.moveDirection = self.moveDirection * self.speed
    self.moveDirection.y = self.moveDirection.y - self.gravity
    self.characterCtrl:Move(self.moveDirection * Time.deltaTime)
end

function Player:operateMove()
    local x = 0
    local z = 0
    if self.characterCtrl.isGrounded then
        if Input.GetKey(KeyCode.W) and not Input.GetKey(KeyCode.S) then
            z = 1
        end

        if Input.GetKey(KeyCode.S) and not Input.GetKey(KeyCode.W) then
            z = -1
        end

        if Input.GetKey(KeyCode.A) and not Input.GetKey(KeyCode.D) then
            x = -1
        end

        if Input.GetKey(KeyCode.D) and not Input.GetKey(KeyCode.A) then
            x = 1
        end

        self.moveDirection = Vector3(x, 0, z)
        self.moveDirection = self.trans:TransformDirection(self.moveDirection)
        self.moveDirection = self.moveDirection * self.speed

        if Input.GetKeyDown(KeyCode.Space) then
            self.moveDirection.y = self.jumpSpeed
        end
    end

    self.moveDirection.y = self.moveDirection.y - self.gravity
    self.characterCtrl:Move(self.moveDirection * Time.deltaTime)

    if Input.GetKey(KeyCode.LeftShift) then
        self.characterCtrl.height = 1.2
        self.characterCtrl.center = Vector3(0, 0.6, 0)
    else
        self.characterCtrl.height = 1.8
        self.characterCtrl.center = Vector3(0, 0.9, 0)
    end
end

function Player:operateRotate()
    if self.isTouched and math.abs(Input.mousePosition.x - self.touchStartX) >= 1 then
        if (self.guideLevelScrollState == 2 and Input.mousePosition.x - self.touchStartX > 0) or 
            (self.guideLevelScrollState == 3 and Input.mousePosition.x - self.touchStartX < 0) or
            self.guideLevelScrollState == 0
        then
            if self.guideLevelScrollState == 2 and self.guideLevelScroll2 == nil then
                self.guideLevelScroll2 = 1
                _gameTools.eventDot(2)
            elseif self.guideLevelScrollState == 3 and self.guideLevelScroll3 == nil then
                self.guideLevelScroll3 = 1
                _gameTools.eventDot(4)
            end

            if self.gunCfg.type == 5 then
                self.rotationY = self.trans.localEulerAngles.y + (Input.mousePosition.x - self.touchStartX) * self.rotationSpeed * gameDataManager.playerData.touchMoveSensitivity  / 30  * Time.deltaTime
            else
                self.rotationY = self.trans.localEulerAngles.y + (Input.mousePosition.x - self.touchStartX) * self.rotationSpeed * gameDataManager.playerData.touchMoveSensitivity  / 10  * Time.deltaTime
            end
        end
    end
    self.touchStartX = Input.mousePosition.x

--    self.firearmsForceOffsetY = self.firearmsForceOffsetY + self.firearmsForce * self.firearmsForceSpeed * Time.deltaTime * 0.2
--    if self.firearmsForceOffsetY <= 0 then
--        self.firearmsForceOffsetY = 0
--    end
--    self.firearmsForceOffsetY = self.firearmsForceOffsetY * self.firearmsShakeYDir

    local angle = Quaternion.Angle(Quaternion.Euler(0,self.rotationY,0), Quaternion.Euler(0,self.rotationMid,0))
    if angle <= self.deltaAngle then
        self.trans.localEulerAngles = Vector3.New(0, self.rotationY, 0)

    end
    

    if self.isChangeRotateY then
        self.isChangeRotateY = false
        self.rotationY = self.trans.localEulerAngles.y
--        self.firearmsForceOffsetY = 0
    end
end

function Player:checkFire()
    if self.isTouched and self.gunCfg.isFreeFire == 1 then
        self.shootDuration = self.shootDuration - Time.deltaTime
        local ray = self.cameraCom:ScreenPointToRay(Vector3.New(Screen.width / 2, Screen.height / 2, 0))
        local isHit, hitInfo = Physics.Raycast(ray, RaycastHit.out)
        if isHit then
            if string.find(hitInfo.collider.gameObject.name, "enemy") then
                self.shootDuration = 0.35
                battleMgr:getUIBattle():crossHairColorState(true)
            else
                battleMgr:getUIBattle():crossHairColorState(false)
            end
        else
            battleMgr:getUIBattle():crossHairColorState(false)
        end

        if self.shootDuration > 0 then
            if self.gunCfg.type == 5 or battleMgr.levelId == 1 then
                self.shootDuration = 0
            end
            if battleMgr.levelId == 1 then
                self.guideLevelScrollState = 1
                battleMgr:getUIBattle():hideGuideShootTips()
                battleMgr:getUIBattle():showPressShootTips(1)
                if battleMgr.curWave == 1 and self.guideLevelShoot1 == nil then
                    self.guideLevelShoot1 = 1
                    _gameTools.eventDot(1)
                elseif battleMgr.curWave == 2 and self.guideLevelShoot2 == nil then
                    self.guideLevelShoot2 = 1
                    _gameTools.eventDot(3)
                elseif battleMgr.curWave == 3 and self.guideLevelShoot3 == nil then
                    self.guideLevelShoot3 = 1
                    _gameTools.eventDot(5)
                end
            end 
            self.weapon:fire(ray, hitInfo)
        end
    else
        battleMgr:getUIBattle():crossHairColorState(false)
    end
end

function Player:sniperFire()
    local ray = self.cameraCom:ScreenPointToRay(Vector3.New(Screen.width / 2, Screen.height / 2, 0))
    local isHit, hitInfo = Physics.Raycast(ray, RaycastHit.out)
    self.weapon:fire(ray, hitInfo)
end

function Player:playOperate()
    if #self.operateList > 0 then
        if self.frameTimer % self.frameCount == 0 then
            self.frameTimer = 0
            local info = table.remove(self.operateList, 1)
            self.lastOperateData = info
            self.trans.position = info.pos
            self.isSquating = info.isSquat
            if self.isSquating then
                self.characterCtrl.height = 1.2
                self.characterCtrl.center = Vector3(0, 0.6, 0)
            else
                self.characterCtrl.height = 1.8
                self.characterCtrl.center = Vector3(0, 0.9, 0)
            end
        else
            local info = self.operateList[1]
            local targetPos = self.lastOperateData.pos + (info.pos - self.lastOperateData.pos) * self.frameTimer / self.frameCount

            local pos1 = targetPos - self.trans.position
            self.walkAudioTimer = self.walkAudioTimer - Time.deltaTime
            if (math.abs(pos1.x) > 0.01 or math.abs(pos1.z) > 0.01) and self.walkAudioTimer <= 0 then
                self.walkAudioTimer = 0.3
                audioMgr:playSound("pl_step"..math.random(1,4))
            end

            if (math.abs(pos1.x) > 0.01 or math.abs(pos1.z) > 0.01) then
                self.armState = 2
            else    
                self.armState = 1
            end

            if self.autoRotate then
                self.rotateTimer = self.rotateTimer + Time.deltaTime
                self.trans.localRotation = Quaternion.Lerp(self.startLocalRotation, Quaternion.Euler(Vector3(0, self.rotationMid, 0)), self.rotateTimer)

--                self.trans.localEulerAngles = Vector3.MoveTowards(self.trans.localEulerAngles, Vector3(0, self.rotationMid, 0), 2)
--                self.trans.forward = Vector3.MoveTowards(self.trans.forward, targetPos - self.trans.position, self.autoRotateSpeed * Time.deltaTime)
                self.rotationY = self.trans.localEulerAngles.y
--                if math.abs(self.rotationY - self.rotationMid) <= 45 then
--                    if Input.GetAxis("Mouse X") ~= 0 then
--                        self.autoRotate = false
--                    end
--                end
                if self.rotateTimer >= 1 then
                    self.autoRotate = false
                end
            end
            self.trans.position = targetPos
        end
        self.frameTimer = self.frameTimer + 1
    else
        self.isPlayOperateFinish = true
        self.autoRotate = false
        self.armState = 1
        battleMgr:setFightState(2)
        battleMgr.enemyCanShoot = true
        battleMgr:getUIBattle():showGuideHpAndBulletNum()
    end
end

function Player:updateFieldOfView()
    if self.isViewZoomIn then
        self.cameraCom.fieldOfView = self.cameraCom.fieldOfView - Time.deltaTime * 500
        if self.cameraCom.fieldOfView <= 30 then
            self.cameraCom.fieldOfView = 30
            self.isViewZoomIn = false
--            self.armRoot.gameObject:SetActive(false)
            self.armRoot.localScale = Vector3.zero
            self.armRoot.localEulerAngles = Vector3(0,-90,0)
        end
        self.armRoot.localEulerAngles = self.armRoot.localEulerAngles + Vector3(0, -180 * Time.deltaTime,0)
        if self.armRoot.localEulerAngles.y <= -90 then
--            self.armRoot.localEulerAngles = Vector3(0,-90,0)
--            self.armRoot.gameObject:SetActive(false)
        end
    elseif self.isViewZoomOut then
        self.cameraCom.fieldOfView = self.cameraCom.fieldOfView + Time.deltaTime * 500
        if self.cameraCom.fieldOfView >= 90 then
            self.cameraCom.fieldOfView = 90
            self.isViewZoomOut = false
            self.armRoot.localEulerAngles = Vector3(0,0,0)
            self.armRoot.localScale = Vector3.one
        end
        self.armRoot.gameObject:SetActive(true)
        self.armRoot.localEulerAngles = self.armRoot.localEulerAngles + Vector3(0, 180 * Time.deltaTime,0)
        if self.armRoot.localEulerAngles.y >= 0 then
            self.armRoot.localEulerAngles = Vector3(0,0,0)
            self.armRoot.localScale = Vector3.one
        end
    end
end

function Player:checkIsSniper(isTouchStart)
    if self.gunCfg.type == 5 then
        if isTouchStart and  not self.weapon.isReloadClip then
            battleMgr:getUIBattle():showSniperView()
            self.isViewZoomIn = true
            self.isViewZoomOut = false
        else
            battleMgr:getUIBattle():hideSniperView()
            self.isViewZoomIn = false
            self.isViewZoomOut = true
            if gameDataManager.guideData.isShowSnipeGuide == nil or gameDataManager.guideData.isShowSnipeGuide == 0 then
                _gameTools.eventDot(104)
            end
            if self.gunCfg.isFreeFire == 0 then
                self:sniperFire()
            end
        end
    end
end

function Player:deathView()
    self.cameraRotateX = self.cameraRotateX - 5 * self.rotationSpeed * Time.deltaTime
    self.cameraRotateX = _gameTools.mathClamp(self.cameraRotateX, self.minRotateX, self.deathRotateX)
    if self.cameraRotateX >= self.deathRotateX then
        
    end
    self.cameraObj.localEulerAngles = Vector3.New(self.cameraRotateX,
        self.cameraObj.localEulerAngles.y, self.cameraObj.localEulerAngles.z)
end

function Player:addForce(force)
    self.firearmsForceSpeed = force * 60
    self.firearmsForce = 1
    self.firearmsForceY = 1
    self.isChangeCameraRotateX = true
    self.isChangeRotateY = true
    self.firearmsShakeYDir = math.random() > 0.5 and 1 or -1
end

function Player:beHit(atk)
    self.curHP = self.curHP - atk

    audioMgr:playSound("pain"..math.random(1, 4))

    if self.curHP <= 20 then
        battleMgr:getUIBattle():showUnHealthyBox()
    else
        battleMgr:getUIBattle():showUnHealthyBox(0.6)
    end

    if self.curHP <= 0 then
        --死亡
        self.curHP = 0
        self:die()
    end

    battleMgr:getUIBattle():refreshHP(self.curHP, self.maxHP)
end

function Player:die()
    if self.isDie then
        return
    end

    audioMgr:playSound("player_death"..math.random(1, 4))
    self.isDie = true
    battleMgr:getUIBattle():deathMaskFadeIn()
end

function Player:clear()
    self.inited = false
    _gameTools.removeUpdate(self.updateHandler)
end

--endregion
